

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter e01
   Declare Ptrsafe Sub nag_1d_aitken_interp Lib "CLW6I26DE_nag.dll" Alias "e01aac" ( _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByVal x As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_everett_interp Lib "CLW6I26DE_nag.dll" Alias "e01abc" ( _
    ByVal n As long, _
    ByVal p As double, _
    ByRef a As double, _
    ByRef g As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_cheb_interp Lib "CLW6I26DE_nag.dll" Alias "e01aec" ( _
    ByVal m As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef p As long, _
    ByVal itmin As long, _
    ByVal itmax As long, _
    ByRef a As double, _
    ByRef perf As double, _
    ByRef num_iter As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_spline_interpolant Lib "CLW6I26DE_nag.dll" Alias "e01bac" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_monotonic_interpolant Lib "CLW6I26DE_nag.dll" Alias "e01bec" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_monotonic_evaluate Lib "CLW6I26DE_nag.dll" Alias "e01bfc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByVal m As long, _
    ByRef px As double, _
    ByRef pf As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_monotonic_deriv Lib "CLW6I26DE_nag.dll" Alias "e01bgc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByVal m As long, _
    ByRef px As double, _
    ByRef pf As double, _
    ByRef pd As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_monotonic_intg Lib "CLW6I26DE_nag.dll" Alias "e01bhc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef integral As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_interpolant Lib "CLW6I26DE_nag.dll" Alias "e01dac" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_triangulate Lib "CLW6I26DE_nag.dll" Alias "e01eac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef triang As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_triang_bary_eval Lib "CLW6I26DE_nag.dll" Alias "e01ebc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef px As double, _
    ByRef py As double, _
    ByRef pf As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_ratnl_interp Lib "CLW6I26DE_nag.dll" Alias "e01rac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef m As long, _
    ByRef a As double, _
    ByRef u As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_ratnl_eval Lib "CLW6I26DE_nag.dll" Alias "e01rbc" ( _
    ByVal m As long, _
    ByRef a As double, _
    ByRef u As double, _
    ByVal x As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_shep_interp Lib "CLW6I26DE_nag.dll" Alias "e01sgc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_shep_eval Lib "CLW6I26DE_nag.dll" Alias "e01shc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef qy As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_triang_interp Lib "CLW6I26DE_nag.dll" Alias "e01sjc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef grads As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_triang_eval Lib "CLW6I26DE_nag.dll" Alias "e01skc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef grads As double, _
    ByVal px As double, _
    ByVal py As double, _
    ByRef pf As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_3d_shep_interp Lib "CLW6I26DE_nag.dll" Alias "e01tgc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef z As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_3d_shep_eval Lib "CLW6I26DE_nag.dll" Alias "e01thc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef z As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef w As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef qy As double, _
    ByRef qz As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_4d_shep_interp Lib "CLW6I26DE_nag.dll" Alias "e01tkc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_4d_shep_eval Lib "CLW6I26DE_nag.dll" Alias "e01tlc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_5d_shep_interp Lib "CLW6I26DE_nag.dll" Alias "e01tmc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_5d_shep_eval Lib "CLW6I26DE_nag.dll" Alias "e01tnc" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_nd_shep_interp Lib "CLW6I26DE_nag.dll" Alias "e01zmc" ( _
    ByVal d As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_nd_shep_eval Lib "CLW6I26DE_nag.dll" Alias "e01znc" ( _
    ByVal d As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef fail As NagError _
   )


' chapter e02
   Declare Ptrsafe Sub nag_1d_cheb_fit Lib "CLW6I26DE_nag.dll" Alias "e02adc" ( _
    ByVal m As long, _
    ByVal kplus1 As long, _
    ByVal tda As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef a As double, _
    ByRef s As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_cheb_eval Lib "CLW6I26DE_nag.dll" Alias "e02aec" ( _
    ByVal nplus1 As long, _
    ByRef a As double, _
    ByVal xcap As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_cheb_interp_fit Lib "CLW6I26DE_nag.dll" Alias "e02afc" ( _
    ByVal nplus1 As long, _
    ByRef f As double, _
    ByRef a As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_cheb_fit_constr Lib "CLW6I26DE_nag.dll" Alias "e02agc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal k As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef w As double, _
    ByVal mf As long, _
    ByRef xf As double, _
    ByRef yf As double, _
    ByRef p As long, _
    ByRef a As double, _
    ByRef s As double, _
    ByRef n As long, _
    ByRef resid As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_cheb_deriv Lib "CLW6I26DE_nag.dll" Alias "e02ahc" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef a As double, _
    ByVal ia1 As long, _
    ByRef patm1 As double, _
    ByRef adif As double, _
    ByVal iadif1 As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_cheb_intg Lib "CLW6I26DE_nag.dll" Alias "e02ajc" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef a As double, _
    ByVal ia1 As long, _
    ByVal qatm1 As double, _
    ByRef aintc As double, _
    ByVal iaint1 As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_cheb_eval2 Lib "CLW6I26DE_nag.dll" Alias "e02akc" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef a As double, _
    ByVal ia1 As long, _
    ByVal x As double, _
    ByRef result As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_minimax_polynomial Lib "CLW6I26DE_nag.dll" Alias "e02alc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal m As long, _
    ByRef a As double, _
    ByRef dnref As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_spline_fit_knots Lib "CLW6I26DE_nag.dll" Alias "e02bac" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByRef ss As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_spline_evaluate Lib "CLW6I26DE_nag.dll" Alias "e02bbc" ( _
    ByVal x As double, _
    ByRef s As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_spline_deriv Lib "CLW6I26DE_nag.dll" Alias "e02bcc" ( _
    ByVal derivs As Nag_DerivType, _
    ByVal x As double, _
    ByRef s As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_spline_intg Lib "CLW6I26DE_nag.dll" Alias "e02bdc" ( _
    ByRef spline As Nag_Spline, _
    ByRef integral As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_spline_fit Lib "CLW6I26DE_nag.dll" Alias "e02bec" ( _
    ByVal start As Nag_Start, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByVal s As double, _
    ByVal nest As long, _
    ByRef fp As double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fit_1dspline_deriv_vector Lib "CLW6I26DE_nag.dll" Alias "e02bfc" ( _
    ByVal start As Nag_SplineVectorSort, _
    ByRef spline As Nag_Spline, _
    ByVal deriv As Nag_DerivType, _
    ByVal xord As Nag_Boolean, _
    ByRef x As double, _
    ByRef ixloc As long, _
    ByVal nx As long, _
    ByRef s As double, _
    ByVal pds As long, _
    ByRef iwrk As long, _
    ByVal liwrk As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_cheb_fit_lines Lib "CLW6I26DE_nag.dll" Alias "e02cac" ( _
    ByRef m As long, _
    ByVal n As long, _
    ByVal k As long, _
    ByVal l As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef w As double, _
    ByRef a As double, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef nux As double, _
    ByVal inuxp1 As long, _
    ByRef nuy As double, _
    ByVal inuyp1 As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_cheb_eval Lib "CLW6I26DE_nag.dll" Alias "e02cbc" ( _
    ByVal mfirst As long, _
    ByVal mlast As long, _
    ByVal k As long, _
    ByVal l As long, _
    ByRef x As double, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByVal y As double, _
    ByVal ymin As double, _
    ByVal ymax As double, _
    ByRef ff As double, _
    ByRef a As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_fit_panel Lib "CLW6I26DE_nag.dll" Alias "e02dac" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef w As double, _
    ByRef point As long, _
    ByRef dl As double, _
    ByVal eps As double, _
    ByRef sigma As double, _
    ByRef rank As long, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_fit_grid Lib "CLW6I26DE_nag.dll" Alias "e02dcc" ( _
    ByVal start As Nag_Start, _
    ByVal mx As long, _
    ByRef x As double, _
    ByVal my As long, _
    ByRef y As double, _
    ByRef f As double, _
    ByVal s As double, _
    ByVal nxest As long, _
    ByVal nyest As long, _
    ByRef fp As double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_fit_scat Lib "CLW6I26DE_nag.dll" Alias "e02ddc" ( _
    ByVal start As Nag_Start, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef weights As double, _
    ByVal s As double, _
    ByVal nxest As long, _
    ByVal nyest As long, _
    ByRef fp As double, _
    ByRef rank As long, _
    ByRef warmstartinf As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_eval Lib "CLW6I26DE_nag.dll" Alias "e02dec" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ff As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_eval_rect Lib "CLW6I26DE_nag.dll" Alias "e02dfc" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ff As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_deriv_rect Lib "CLW6I26DE_nag.dll" Alias "e02dhc" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal nux As long, _
    ByVal nuy As long, _
    ByRef z As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_lone_fit Lib "CLW6I26DE_nag.dll" Alias "e02gac" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal nplus2 As long, _
    ByVal toler As double, _
    ByRef x As double, _
    ByRef resid As double, _
    ByRef rank As long, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_linf_fit Lib "CLW6I26DE_nag.dll" Alias "e02gcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal tol As double, _
    ByRef relerr As double, _
    ByRef x As double, _
    ByRef resmax As double, _
    ByRef rank As long, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_fit_ts_scat Lib "CLW6I26DE_nag.dll" Alias "e02jdc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByVal lsminp As long, _
    ByVal lsmaxp As long, _
    ByVal nxcels As long, _
    ByVal nycels As long, _
    ByVal lcoefs As long, _
    ByRef coefs As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_ts_eval Lib "CLW6I26DE_nag.dll" Alias "e02jec" ( _
    ByVal nevalv As long, _
    ByRef xevalv As double, _
    ByRef yevalv As double, _
    ByRef coefs As double, _
    ByRef fevalv As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_spline_ts_eval_rect Lib "CLW6I26DE_nag.dll" Alias "e02jfc" ( _
    ByVal nxeval As long, _
    ByVal nyeval As long, _
    ByRef xevalm As double, _
    ByRef yevalm As double, _
    ByRef coefs As double, _
    ByRef fevalm As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_pade Lib "CLW6I26DE_nag.dll" Alias "e02rac" ( _
    ByVal ia As long, _
    ByVal ib As long, _
    ByRef c As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_1d_pade_eval Lib "CLW6I26DE_nag.dll" Alias "e02rbc" ( _
    ByRef a As double, _
    ByVal ia As long, _
    ByRef b As double, _
    ByVal ib As long, _
    ByVal x As double, _
    ByRef ans As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_2d_panel_sort Lib "CLW6I26DE_nag.dll" Alias "e02zac" ( _
    ByVal px As long, _
    ByVal py As long, _
    ByRef lamda As double, _
    ByRef mu As double, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef point As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fit_opt_set Lib "CLW6I26DE_nag.dll" Alias "e02zkc" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_fit_opt_get Lib "CLW6I26DE_nag.dll" Alias "e02zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


' chapter e04
' skeleton code for callback function
'  Sub nag_opt_one_var_no_deriv_funct( _
'      ByVal xc As double, _
'      ByRef fc As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_one_var_no_deriv Lib "CLW6I26DE_nag.dll" Alias "e04abc" ( _
    ByVal funct As longPtr, _
    ByVal e1 As double, _
    ByVal e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal max_fun As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_one_var_deriv_funct( _
'      ByVal xc As double, _
'      ByRef fc As double, _
'      ByRef gc As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_one_var_deriv Lib "CLW6I26DE_nag.dll" Alias "e04bbc" ( _
    ByVal funct As longPtr, _
    ByVal e1 As double, _
    ByVal e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal max_fun As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_simplex_easy_funct( _
'      ByVal n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_simplex_easy_monit( _
'      ByVal fmin As double, _
'      ByVal fmax As double, _
'      ByVal sim_rptr As longPtr, _
'      ByVal n As long, _
'      ByVal ncall As long, _
'      ByVal serror As double, _
'      ByVal vratio As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_simplex_easy Lib "CLW6I26DE_nag.dll" Alias "e04cbc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal tolf As double, _
    ByVal tolx As double, _
    ByVal funct As longPtr, _
    ByVal monit As longPtr, _
    ByVal maxcal As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_conj_grad_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_conj_grad Lib "CLW6I26DE_nag.dll" Alias "e04dgc" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_lsq_no_deriv_lsqfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_lsq_no_deriv Lib "CLW6I26DE_nag.dll" Alias "e04fcc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal lsqfun As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_lsq_deriv_lsqfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByVal tdfjac As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_lsq_deriv Lib "CLW6I26DE_nag.dll" Alias "e04gbc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal lsqfun As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_check_deriv_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_check_deriv Lib "CLW6I26DE_nag.dll" Alias "e04hcc" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_check_2nd_deriv_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_check_2nd_deriv_hessfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal h_rptr As longPtr, _
'      ByVal hd_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_check_2nd_deriv Lib "CLW6I26DE_nag.dll" Alias "e04hdc" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal hessfun As longPtr, _
    ByRef x As double, _
    ByRef g As double, _
    ByRef hesl As double, _
    ByRef hesd As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_bounds_qa_no_deriv_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef f As double, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_bounds_qa_no_deriv_monfun( _
'      ByVal n As long, _
'      ByVal nf As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f As double, _
'      ByVal rho As double, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_bounds_qa_no_deriv Lib "CLW6I26DE_nag.dll" Alias "e04jcc" ( _
    ByVal objfun As longPtr, _
    ByVal n As long, _
    ByVal npt As long, _
    ByRef x As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal rhobeg As double, _
    ByVal rhoend As double, _
    ByVal monfun As longPtr, _
    ByVal maxcal As long, _
    ByRef f As double, _
    ByRef nf As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_bounds_deriv_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_bounds_deriv Lib "CLW6I26DE_nag.dll" Alias "e04kbc" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal bound As Nag_BoundType, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_bounds_2nd_deriv_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_bounds_2nd_deriv_hessfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal h_rptr As longPtr, _
'      ByVal hd_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_bounds_2nd_deriv Lib "CLW6I26DE_nag.dll" Alias "e04lbc" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal hessfun As longPtr, _
    ByVal bound As Nag_BoundType, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_lp Lib "CLW6I26DE_nag.dll" Alias "e04mfc" ( _
    ByVal n As long, _
    ByVal nclin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef cvec As double, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_miqp_mps_write Lib "CLW6I26DE_nag.dll" Alias "e04mwc" ( _
    ByVal fileid As long, ByVal n As long, ByVal m As long, _
    ByVal nnzc As long, ByVal nnza As long, ByVal ncolh As long, _
    ByVal nnzh As long, ByVal lintvar As long, ByRef idxc As long, _
    ByRef c As double, ByVal iobj As long, ByRef a As double, _
    ByRef irowa As long, ByRef iccola As long, ByRef bl As double, _
    ByRef bu As double, ByVal pnames As String, ByVal crname As String, _
    ByRef h As double, ByRef irowh As long, ByRef iccolh As long, _
    ByVal minmax As long, ByRef intvar As long, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_miqp_mps_read Lib "CLW6I26DE_nag.dll" Alias "e04mxc" ( _
    ByVal fileid As long, ByVal maxn As long, ByVal maxm As long, _
    ByVal maxnnz As long, ByVal maxncolh As long, ByVal maxnnzh As long, _
    ByVal maxlintvar As long, ByVal mpslst As long, ByRef n As long, _
    ByRef m As long, ByRef nnz As long, ByRef ncolh As long, _
    ByRef nnzh As long, ByRef lintvar As long, ByRef iobj As long, _
    ByRef a As double, ByRef irowa As long, ByRef iccola As long, _
    ByRef bl As double, ByRef bu As double, ByVal pnames As String, _
    ByRef nname As long, ByVal crname As String, ByRef h As double, _
    ByRef irowh As long, ByRef iccolh As long, ByRef minmax As long, _
    ByRef intvar As long, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_mps_free Lib "CLW6I26DE_nag.dll" Alias "e04myc" ( _
    ByRef aptr As longPtr, _
    ByRef haptr As longPtr, _
    ByRef kaptr As longPtr, _
    ByRef blptr As longPtr, _
    ByRef buptr As longPtr, _
    ByRef xsptr As longPtr _
   )

   Declare Ptrsafe Sub nag_opt_sparse_mps_read Lib "CLW6I26DE_nag.dll" Alias "e04mzc" ( _
    ByVal mps_fileptr As longPtr, _
    ByRef n As long, _
    ByRef m As long, _
    ByRef nnz As long, _
    ByRef iobj As long, _
    ByRef aptr As longPtr, _
    ByRef haptr As longPtr, _
    ByRef kaptr As longPtr, _
    ByRef blptr As longPtr, _
    ByRef buptr As longPtr, _
    ByRef xsptr As longPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_lin_lsq Lib "CLW6I26DE_nag.dll" Alias "e04ncc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal nclin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef cvec As double, _
    ByRef b As double, _
    ByRef h As double, _
    ByVal tdh As long, _
    ByRef kx As long, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_qp_qphess( _
'      ByVal n As long, _
'      ByVal jthcol As long, _
'      ByVal h_rptr As longPtr, _
'      ByVal tdh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_qp Lib "CLW6I26DE_nag.dll" Alias "e04nfc" ( _
    ByVal n As long, _
    ByVal nclin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef cvec As double, _
    ByRef h As double, _
    ByVal tdh As long, _
    ByVal qphess As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_sparse_convex_qp_qphx( _
'      ByVal ncolh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp Lib "CLW6I26DE_nag.dll" Alias "e04nkc" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByVal nnz As long, _
    ByVal iobj As long, _
    ByVal ncolh As long, _
    ByVal qphx As longPtr, _
    ByRef a As double, _
    ByRef ha As long, _
    ByRef ka As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef xs As double, _
    ByRef ninf As long, _
    ByRef sinf As double, _
    ByRef obj As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_init Lib "CLW6I26DE_nag.dll" Alias "e04npc" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_sparse_convex_qp_solve_qphx( _
'      ByVal ncolh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_solve Lib "CLW6I26DE_nag.dll" Alias "e04nqc" ( _
    ByVal start As Nag_Start, ByVal qphx As longPtr, _
    ByVal m As long, _
    ByVal n As long, ByVal ne As long, ByVal nname As long, _
    ByVal lenc As long, ByVal ncolh As long, ByVal iobj As long, _
    ByVal objadd As double, ByVal prob As String, ByRef acol As double, _
    ByRef inda As long, ByRef loca As long, ByRef bl As double, _
    ByRef bu As double, ByRef c As double, ByRef names As longPtr, _
    ByRef helast As long, ByRef hs As long, ByRef x As double, _
    ByRef pi As double, ByRef rc As double, ByRef ns As long, _
    ByRef ninf As long, ByRef sinf As double, ByRef obj As double, _
    ByRef state As Nag_E04State, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_option_set_file Lib "CLW6I26DE_nag.dll" Alias "e04nrc" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_option_set_string Lib "CLW6I26DE_nag.dll" Alias "e04nsc" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_option_set_integer Lib "CLW6I26DE_nag.dll" Alias "e04ntc" ( _
    ByVal st As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_option_set_double Lib "CLW6I26DE_nag.dll" Alias "e04nuc" ( _
    ByVal st As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_option_get_integer Lib "CLW6I26DE_nag.dll" Alias "e04nxc" ( _
    ByVal st As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_convex_qp_option_get_double Lib "CLW6I26DE_nag.dll" Alias "e04nyc" ( _
    ByVal st As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_bnd_lin_lsq Lib "CLW6I26DE_nag.dll" Alias "e04pcc" ( _
    ByVal itype As Nag_RegularizedType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByRef b As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal tol As double, _
    ByRef x As double, _
    ByRef rnorm As double, _
    ByRef nfree As long, _
    ByRef w As double, _
    ByRef indx As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_init Lib "CLW6I26DE_nag.dll" Alias "e04rac" ( _
    ByRef handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sdp_read_sdpa Lib "CLW6I26DE_nag.dll" Alias "e04rdc" ( _
    ByVal infile As long, _
    ByVal maxnvar As long, _
    ByVal maxnblk As long, _
    ByVal maxnnz As long, _
    ByVal filelst As long, _
    ByRef nvar As long, _
    ByRef nblk As long, _
    ByRef nnz As long, _
    ByRef cvec As double, _
    ByRef nnza As long, _
    ByRef irowa As long, _
    ByRef icola As long, _
    ByRef a As double, _
    ByRef blksizea As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_linobj Lib "CLW6I26DE_nag.dll" Alias "e04rec" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef cvec As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_quadobj Lib "CLW6I26DE_nag.dll" Alias "e04rfc" ( _
    ByVal handleptr As longPtr, _
    ByVal nnzc As long, _
    ByRef idxc As long, _
    ByRef c As double, _
    ByVal nnzh As long, _
    ByRef irowh As long, _
    ByRef icolh As long, _
    ByRef h As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_nlnobj Lib "CLW6I26DE_nag.dll" Alias "e04rgc" ( _
    ByVal handleptr As longPtr, _
    ByVal nnzfd As long, _
    ByRef idxfd As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_simplebounds Lib "CLW6I26DE_nag.dll" Alias "e04rhc" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_linconstr Lib "CLW6I26DE_nag.dll" Alias "e04rjc" ( _
    ByVal handleptr As longPtr, _
    ByVal nclin As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal nnzb As long, _
    ByRef irowb As long, _
    ByRef icolb As long, _
    ByRef b As double, _
    ByRef idlc As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_nlnconstr Lib "CLW6I26DE_nag.dll" Alias "e04rkc" ( _
    ByVal handleptr As longPtr, _
    ByVal ncnln As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal nnzgd As long, _
    ByRef irowgd As long, _
    ByRef icolgd As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_nlnhess Lib "CLW6I26DE_nag.dll" Alias "e04rlc" ( _
    ByVal handleptr As longPtr, _
    ByVal idf As long, _
    ByVal nnzh As long, _
    ByRef irowh As long, _
    ByRef icolh As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_linmatineq Lib "CLW6I26DE_nag.dll" Alias "e04rnc" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByVal dima As long, _
    ByRef nnza As long, _
    ByVal nnzasum As long, _
    ByRef irowa As long, _
    ByRef icola As long, _
    ByRef a As double, _
    ByVal nblk As long, _
    ByRef blksizea As long, _
    ByRef idblk As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_set_quadmatineq Lib "CLW6I26DE_nag.dll" Alias "e04rpc" ( _
    ByVal handleptr As longPtr, _
    ByVal nq As long, _
    ByRef qi As long, _
    ByRef qj As long, _
    ByVal dimq As long, _
    ByRef nnzq As long, _
    ByVal nnzqsum As long, _
    ByRef irowq As long, _
    ByRef icolq As long, _
    ByRef q As double, _
    ByRef idblk As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_print Lib "CLW6I26DE_nag.dll" Alias "e04ryc" ( _
    ByVal handleptr As longPtr, _
    ByVal fileid As long, _
    ByVal cmdstr As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_free Lib "CLW6I26DE_nag.dll" Alias "e04rzc" ( _
    ByRef handleptr As longPtr, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_handle_solve_ipopt_objfun( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef fx As double, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_handle_solve_ipopt_objgrd( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal nnzfd As long, _
'      ByVal fdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_handle_solve_ipopt_confun( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal ncnln As long, _
'      ByVal gx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_handle_solve_ipopt_congrd( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal nnzgd As long, _
'      ByVal gdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_handle_solve_ipopt_hess( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal ncnln As long, _
'      ByVal idf As long, _
'      ByVal sigma As double, _
'      ByVal lambda_rptr As longPtr, _
'      ByVal nnzh As long, _
'      ByVal hx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_handle_solve_ipopt_mon( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal nnzu As long, _
'      ByVal u_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_handle_solve_ipopt Lib "CLW6I26DE_nag.dll" Alias "e04stc" ( _
    ByVal handleptr As longPtr, _
    ByVal objfun As longPtr, _
    ByVal objgrd As longPtr, _
    ByVal confun As longPtr, _
    ByVal congrd As longPtr, _
    ByVal hess As longPtr, _
    ByVal mon As longPtr, _
    ByVal nvar As long, _
    ByRef x As double, _
    ByVal nnzu As long, _
    ByRef u As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_solve_pennon Lib "CLW6I26DE_nag.dll" Alias "e04svc" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef x As double, _
    ByVal nnzu As long, _
    ByRef u As double, _
    ByVal nnzuc As long, _
    ByRef uc As double, _
    ByVal nnzua As long, _
    ByRef ua As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef inform As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_nlp_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_nlp_confun( _
'      ByVal n As long, _
'      ByVal ncnlin As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal conf_rptr As longPtr, _
'      ByVal conjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_nlp Lib "CLW6I26DE_nag.dll" Alias "e04ucc" ( _
    ByVal n As long, _
    ByVal nclin As long, _
    ByVal ncnlin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal objfun As longPtr, _
    ByVal confun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_revcomm_option_set_file Lib "CLW6I26DE_nag.dll" Alias "e04udc" ( _
    ByVal fileid As long, _
    ByRef lwsav As Nag_Boolean, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_revcomm_option_set_string Lib "CLW6I26DE_nag.dll" Alias "e04uec" ( _
    ByVal str As String, _
    ByRef lwsav As Nag_Boolean, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_revcomm Lib "CLW6I26DE_nag.dll" Alias "e04ufc" ( _
    ByRef irevcm As long, ByVal n As long, ByVal nclin As long, _
    ByVal ncnln As long, ByVal tda As long, ByVal tdcj As long, _
    ByVal tdr As long, ByRef a As double, ByRef bl As double, _
    ByRef bu As double, ByRef iter As long, ByRef istate As long, _
    ByRef c As double, ByRef cjac As double, ByRef clamda As double, _
    ByRef objf As double, ByRef objgrd As double, ByRef r As double, _
    ByRef x As double, ByRef needc As long, ByRef iwork As long, _
    ByVal liwork As long, ByRef work As double, ByVal lwork As long, _
    ByVal cwsav As String, ByRef lwsav As Nag_Boolean, ByRef iwsav As long, _
    ByRef rwsav As double, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_nlp_sparse_confun( _
'      ByVal ncnln As long, _
'      ByVal njnln As long, _
'      ByVal nnzjac As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal conf_rptr As longPtr, _
'      ByVal conjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_nlp_sparse_objfun( _
'      ByVal nonln As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrad_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_nlp_sparse Lib "CLW6I26DE_nag.dll" Alias "e04ugc" ( _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByVal n As long, _
    ByVal m As long, ByVal ncnln As long, ByVal nonln As long, _
    ByVal njnln As long, ByVal iobj As long, ByVal nnz As long, _
    ByRef a As double, ByRef ha As long, ByRef ka As long, _
    ByRef bl As double, ByRef bu As double, ByRef xs As double, _
    ByRef ninf As long, ByRef sinf As double, ByRef objf As double, _
    ByRef comm As Nag_Comm, ByRef ops As Nag_E04_Opt, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_nlin_lsq_objfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByVal tdfjac As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_nlin_lsq_confun( _
'      ByVal n As long, _
'      ByVal ncnlin As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal conf_rptr As longPtr, _
'      ByVal conjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_nlin_lsq Lib "CLW6I26DE_nag.dll" Alias "e04unc" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal nclin As long, _
    ByVal ncnlin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef y As double, _
    ByVal objfun As longPtr, _
    ByVal confun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef f As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_nlp_init Lib "CLW6I26DE_nag.dll" Alias "e04vgc" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_sparse_nlp_solve_usrfun( _
'      ByRef status As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal needf As long, _
'      ByVal nf As long, _
'      ByVal f_rptr As longPtr, _
'      ByVal needg As long, _
'      ByVal leng As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_sparse_nlp_solve Lib "CLW6I26DE_nag.dll" Alias "e04vhc" ( _
    ByVal start As Nag_Start, ByVal nf As long, ByVal n As long, _
    ByVal nxname As long, ByVal nfname As long, ByVal objadd As double, _
    ByRef objrow As long, ByVal prob As String, ByVal usrfun As longPtr, _
    ByRef iafun As long, ByRef javar As long, ByRef a As double, _
    ByVal lena As long, ByVal nea As long, ByRef igfun As long, _
    ByRef jgvar As long, ByVal leng As long, ByVal neg As long, _
    ByRef xlow As double, ByRef xupp As double, ByRef xnames As longPtr, _
    ByRef flow As double, ByRef fupp As double, ByRef fnames As longPtr, _
    ByRef x As double, ByRef xstate As long, ByRef xmul As double, _
    ByRef f As double, ByRef fstate As long, ByRef fmul As double, _
    ByRef ns As long, ByRef ninf As long, ByRef sinf As double, _
    ByRef state As Nag_E04State, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_sparse_nlp_jacobian_usrfun( _
'      ByRef status As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal needf As long, _
'      ByVal nf As long, _
'      ByVal f_rptr As longPtr, _
'      ByVal needg As long, _
'      ByVal leng As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_sparse_nlp_jacobian Lib "CLW6I26DE_nag.dll" Alias "e04vjc" ( _
    ByVal nf As long, ByVal n As long, ByVal usrfun As longPtr, _
    ByRef iafun As long, ByRef javar As long, ByRef a As double, _
    ByVal lena As long, ByRef nea As long, ByRef igfun As long, _
    ByRef jgvar As long, ByVal leng As long, ByRef neg As long, _
    ByRef x As double, ByRef xlow As double, ByRef xupp As double, _
    ByRef state As Nag_E04State, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_nlp_option_set_file Lib "CLW6I26DE_nag.dll" Alias "e04vkc" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_nlp_option_set_string Lib "CLW6I26DE_nag.dll" Alias "e04vlc" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_nlp_option_set_integer Lib "CLW6I26DE_nag.dll" Alias "e04vmc" ( _
    ByVal st As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_nlp_option_set_double Lib "CLW6I26DE_nag.dll" Alias "e04vnc" ( _
    ByVal st As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_nlp_option_get_integer Lib "CLW6I26DE_nag.dll" Alias "e04vrc" ( _
    ByVal st As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_sparse_nlp_option_get_double Lib "CLW6I26DE_nag.dll" Alias "e04vsc" ( _
    ByVal st As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_revcomm_init Lib "CLW6I26DE_nag.dll" Alias "e04wbc" ( _
    ByVal rname As String, _
    ByVal cwsav As String, _
    ByVal lcwsav As long, _
    ByRef lwsav As Nag_Boolean, _
    ByVal llwsav As long, _
    ByRef iwsav As long, _
    ByVal liwsav As long, _
    ByRef rwsav As double, _
    ByVal lrwsav As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_init Lib "CLW6I26DE_nag.dll" Alias "e04wcc" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_nlp_solve_confun( _
'      ByRef mode As long, _
'      ByVal ncnln As long, _
'      ByVal n As long, _
'      ByVal tdcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal ccon_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_opt_nlp_solve_objfun( _
'      ByRef mode As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal grad_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_nlp_solve Lib "CLW6I26DE_nag.dll" Alias "e04wdc" ( _
    ByVal n As long, ByVal nclin As long, ByVal ncnln As long, _
    ByVal tda As long, ByVal tdcj As long, ByVal tdh As long, _
    ByRef a As double, ByRef bl As double, ByRef bu As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef majits As long, _
    ByRef istate As long, ByRef ccon As double, ByRef cjac As double, _
    ByRef clamda As double, ByRef objf As double, ByRef grad As double, _
    ByRef h As double, ByRef x As double, ByRef state As Nag_E04State, ByRef comm As Nag_Comm, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_option_set_file Lib "CLW6I26DE_nag.dll" Alias "e04wec" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_option_set_string Lib "CLW6I26DE_nag.dll" Alias "e04wfc" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_option_set_integer Lib "CLW6I26DE_nag.dll" Alias "e04wgc" ( _
    ByVal st As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_option_set_double Lib "CLW6I26DE_nag.dll" Alias "e04whc" ( _
    ByVal st As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_option_get_integer Lib "CLW6I26DE_nag.dll" Alias "e04wkc" ( _
    ByVal st As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_nlp_option_get_double Lib "CLW6I26DE_nag.dll" Alias "e04wlc" ( _
    ByVal st As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_estimate_deriv_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_estimate_deriv Lib "CLW6I26DE_nag.dll" Alias "e04xac" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal objfun As longPtr, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef h_forward As double, _
    ByRef h_central As double, _
    ByRef hess As double, _
    ByVal tdhess As long, _
    ByRef deriv_info As Nag_DerivInfo, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_init Lib "CLW6I26DE_nag.dll" Alias "e04xxc" ( _
    ByRef ops As Nag_E04_Opt _
   )

   Declare Ptrsafe Sub nag_opt_read Lib "CLW6I26DE_nag.dll" Alias "e04xyc" ( _
    ByVal nmptr As longPtr, _
    ByVal opt_fileptr As longPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByVal dnprint As Nag_Boolean, _
    ByVal outfileptr As longPtr, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_free Lib "CLW6I26DE_nag.dll" Alias "e04xzc" ( _
    ByRef ops As Nag_E04_Opt, _
    ByVal p_nameptr As longPtr, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_opt_lsq_check_deriv_lsqfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByVal tdfjac As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_opt_lsq_check_deriv Lib "CLW6I26DE_nag.dll" Alias "e04yac" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal lsqfun As longPtr, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_lsq_covariance Lib "CLW6I26DE_nag.dll" Alias "e04ycc" ( _
    ByVal job As long, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal fsumsq As double, _
    ByRef cj As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_opt_set Lib "CLW6I26DE_nag.dll" Alias "e04zmc" ( _
    ByVal handleptr As longPtr, _
    ByVal optstr As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_opt_get Lib "CLW6I26DE_nag.dll" Alias "e04znc" ( _
    ByVal handleptr As longPtr, _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_opt_handle_opt_set_file Lib "CLW6I26DE_nag.dll" Alias "e04zpc" ( _
    ByVal handleptr As longPtr, _
    ByVal fileid As long, _
    ByRef fail As NagError _
   )


' chapter e05
   Declare Ptrsafe Sub nag_glopt_bnd_mcs_init Lib "CLW6I26DE_nag.dll" Alias "e05jac" ( _
    ByVal n_r As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_glopt_bnd_mcs_solve_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef f As double, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_bnd_mcs_solve_monit( _
'      ByVal n As long, _
'      ByVal ncall As long, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal icount_iptr As longPtr, _
'      ByVal ninit As long, _
'      ByVal list_rptr As longPtr, _
'      ByVal numpts_iptr As longPtr, _
'      ByVal initpt_iptr As longPtr, _
'      ByVal nbaskt As long, _
'      ByVal xbaskt_rptr As longPtr, _
'      ByVal boxl_rptr As longPtr, _
'      ByVal boxu_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_solve Lib "CLW6I26DE_nag.dll" Alias "e05jbc" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal bound As Nag_BoundType, _
    ByVal initmethod As Nag_MCSInitMethod, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal sdlist As long, _
    ByRef list As double, _
    ByRef numpts As long, _
    ByRef initpt As long, _
    ByVal monit As longPtr, _
    ByRef x As double, _
    ByRef obj As double, _
    ByRef state As Nag_E05State, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_optset_file Lib "CLW6I26DE_nag.dll" Alias "e05jcc" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_optset_string Lib "CLW6I26DE_nag.dll" Alias "e05jdc" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_optset_char Lib "CLW6I26DE_nag.dll" Alias "e05jec" ( _
    ByVal optstr As String, _
    ByVal cvalue As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_optset_int Lib "CLW6I26DE_nag.dll" Alias "e05jfc" ( _
    ByVal optstr As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_optset_real Lib "CLW6I26DE_nag.dll" Alias "e05jgc" ( _
    ByVal optstr As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Function nag_glopt_bnd_mcs_option_check Lib "CLW6I26DE_nag.dll" Alias "e05jhc" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   ) As long

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_optget_int Lib "CLW6I26DE_nag.dll" Alias "e05jkc" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_bnd_mcs_optget_real Lib "CLW6I26DE_nag.dll" Alias "e05jlc" ( _
    ByVal optstr As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_glopt_bnd_pso_objfun( _
'      ByRef mode As long, _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal vecout_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_bnd_pso_monmod( _
'      ByVal ndim As long, _
'      ByVal npar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xb_rptr As longPtr, _
'      ByVal fb As double, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal fbest_rptr As longPtr, _
'      ByVal itt_iptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_glopt_bnd_pso Lib "CLW6I26DE_nag.dll" Alias "e05sac" ( _
    ByVal ndim As long, _
    ByVal npar As long, _
    ByRef xb As double, _
    ByRef fb As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal objfun As longPtr, _
    ByVal monmod As longPtr, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef comm As Nag_Comm, _
    ByRef itt As long, _
    ByRef inform As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_glopt_nlp_pso_objfun( _
'      ByRef mode As long, _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal vecout_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_nlp_pso_confun( _
'      ByRef mode As long, _
'      ByVal ncon As long, _
'      ByVal ndim As long, _
'      ByVal tdcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_nlp_pso_monmod( _
'      ByVal ndim As long, _
'      ByVal ncon As long, _
'      ByVal npar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xb_rptr As longPtr, _
'      ByVal fb As double, _
'      ByVal cb_rptr As longPtr, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal fbest_rptr As longPtr, _
'      ByVal cbest_rptr As longPtr, _
'      ByVal itt_iptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_glopt_nlp_pso Lib "CLW6I26DE_nag.dll" Alias "e05sbc" ( _
    ByVal ndim As long, ByVal ncon As long, ByVal npar As long, _
    ByRef xb As double, ByRef fb As double, ByRef cb As double, _
    ByRef bl As double, ByRef bu As double, ByRef xbest As double, _
    ByRef fbest As double, ByRef cbest As double, ByVal objfun As longPtr, _
    ByVal confun As longPtr, _
    ByVal monmod As longPtr, ByRef iopts As long, _
    ByRef opts As double, ByRef comm As Nag_Comm, _
    ByRef itt As long, ByRef inform As long, ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_glopt_nlp_multistart_sqp_confun( _
'      ByRef mode As long, _
'      ByVal ncnln As long, _
'      ByVal n As long, _
'      ByVal tdcjsl As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjsl_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_nlp_multistart_sqp_objfun( _
'      ByRef mode As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_nlp_multistart_sqp_start( _
'      ByVal npts As long, _
'      ByVal quas_rptr As longPtr, _
'      ByVal n As long, _
'      ByVal repeat As Nag_Boolean, _
'      ByVal bl_rptr As longPtr, _
'      ByVal bu_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef mode As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_glopt_nlp_multistart_sqp Lib "CLW6I26DE_nag.dll" Alias "e05ucc" ( _
    ByVal n As long, ByVal nclin As long, ByVal ncnln As long, _
    ByRef a As double, ByVal tda As long, ByRef bl As double, _
    ByRef bu As double, ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByVal npts As long, ByRef x As double, ByVal ldx As long, _
    ByVal start As longPtr, _
    ByVal repeat As Nag_Boolean, ByVal nb As long, _
    ByRef objf As double, ByRef objgrd As double, ByVal ldobjgrd As long, _
    ByRef iter As long, ByRef c As double, ByVal ldc As long, _
    ByRef cjac As double, ByVal ldcjac As long, ByVal sdcjac As long, _
    ByRef r As double, ByVal ldr As long, ByVal sdr As long, _
    ByRef clamda As double, ByVal ldclamda As long, ByRef istate As long, _
    ByVal ldistate As long, ByRef iopts As long, ByRef opts As double, ByRef comm As Nag_Comm, ByRef info As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Sub nag_glopt_nlp_multistart_sqp_lsq_confun( _
'      ByRef mode As long, _
'      ByVal ncnln As long, _
'      ByVal n As long, _
'      ByVal pdcjsl As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjsl_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_nlp_multistart_sqp_lsq_objfun( _
'      ByRef mode As long, _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal pdfjsl As long, _
'      ByVal needfi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjsl_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub nag_glopt_nlp_multistart_sqp_lsq_start( _
'      ByVal npts As long, _
'      ByVal quas_rptr As longPtr, _
'      ByVal n As long, _
'      ByVal repeat1 As Nag_Boolean, _
'      ByVal bl_rptr As longPtr, _
'      ByVal bu_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef mode As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub nag_glopt_nlp_multistart_sqp_lsq Lib "CLW6I26DE_nag.dll" Alias "e05usc" ( _
    ByVal m As long, ByVal n As long, ByVal nclin As long, _
    ByVal ncnln As long, ByRef a As double, ByVal pda As long, _
    ByRef bl As double, ByRef bu As double, ByRef y As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByVal npts As long, _
    ByRef x As double, ByVal pdx As long, ByVal start As longPtr, _
    ByVal repeat1 As Nag_Boolean, ByVal nb As long, ByRef objf As double, _
    ByRef f As double, ByRef fjac As double, ByVal ldfjac As long, _
    ByVal sdfjac As long, ByRef iter As long, ByRef c As double, _
    ByVal pdc As long, ByRef cjac As double, ByVal ldcjac As long, _
    ByVal sdcjac As long, ByRef clamda As double, ByVal pdclamda As long, _
    ByRef istate As long, ByVal pdistate As long, ByRef iopts As long, _
    ByRef opts As double, ByRef comm As Nag_Comm, _
    ByRef info As long, ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_opt_set Lib "CLW6I26DE_nag.dll" Alias "e05zkc" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_glopt_opt_get Lib "CLW6I26DE_nag.dll" Alias "e05zlc" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )

