

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.
' chapter e01

   Declare Ptrsafe Sub e01aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByVal x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal p As double, _
    ByRef a As double, _
    ByRef g As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01aec Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef p As long, _
    ByVal itmin As long, _
    ByVal itmax As long, _
    ByRef a As double, _
    ByRef perf As double, _
    ByRef num_iter As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01bac Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01bec Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01bfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByVal m As long, _
    ByRef px As double, _
    ByRef pf As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01bgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByVal m As long, _
    ByRef px As double, _
    ByRef pf As double, _
    ByRef pd As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01bhc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef integral As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01eac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef triang As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01ebc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef px As double, _
    ByRef py As double, _
    ByRef pf As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01rac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef m As long, _
    ByRef a As double, _
    ByRef u As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01rbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef a As double, _
    ByRef u As double, _
    ByVal x As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01sgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01shc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef qy As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01sjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef grads As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01skc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef grads As double, _
    ByVal px As double, _
    ByVal py As double, _
    ByRef pf As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01tgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef z As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01thc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef z As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef w As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef qy As double, _
    ByRef qz As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01tkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01tlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01tmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01tnc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01zmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal d As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal nw As long, _
    ByVal nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e01znc Lib "CLW6I26DE_nag.dll" ( _
    ByVal d As long, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByVal n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef fail As NagError _
   )


' chapter e02

   Declare Ptrsafe Sub e02adc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal kplus1 As long, _
    ByVal tda As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef a As double, _
    ByRef s As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02aec Lib "CLW6I26DE_nag.dll" ( _
    ByVal nplus1 As long, _
    ByRef a As double, _
    ByVal xcap As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02afc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nplus1 As long, _
    ByRef f As double, _
    ByRef a As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02agc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal k As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef w As double, _
    ByVal mf As long, _
    ByRef xf As double, _
    ByRef yf As double, _
    ByRef p As long, _
    ByRef a As double, _
    ByRef s As double, _
    ByRef n As long, _
    ByRef resid As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02ahc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef a As double, _
    ByVal ia1 As long, _
    ByRef patm1 As double, _
    ByRef adif As double, _
    ByVal iadif1 As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02ajc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef a As double, _
    ByVal ia1 As long, _
    ByVal qatm1 As double, _
    ByRef aintc As double, _
    ByVal iaint1 As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02akc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByRef a As double, _
    ByVal ia1 As long, _
    ByVal x As double, _
    ByRef result As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02alc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal m As long, _
    ByRef a As double, _
    ByRef dnref As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02bac Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByRef ss As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02bbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByRef s As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02bcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal derivs As Nag_DerivType, _
    ByVal x As double, _
    ByRef s As double, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02bdc Lib "CLW6I26DE_nag.dll" ( _
    ByRef spline As Nag_Spline, _
    ByRef integral As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02bec Lib "CLW6I26DE_nag.dll" ( _
    ByVal start As Nag_Start, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef weights As double, _
    ByVal s As double, _
    ByVal nest As long, _
    ByRef fp As double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_Spline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02bfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal start As Nag_SplineVectorSort, _
    ByRef spline As Nag_Spline, _
    ByVal deriv As Nag_DerivType, _
    ByVal xord As Nag_Boolean, _
    ByRef x As double, _
    ByRef ixloc As long, _
    ByVal nx As long, _
    ByRef s As double, _
    ByVal pds As long, _
    ByRef iwrk As long, _
    ByVal liwrk As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02cac Lib "CLW6I26DE_nag.dll" ( _
    ByRef m As long, _
    ByVal n As long, _
    ByVal k As long, _
    ByVal l As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef w As double, _
    ByRef a As double, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef nux As double, _
    ByVal inuxp1 As long, _
    ByRef nuy As double, _
    ByVal inuyp1 As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02cbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mfirst As long, _
    ByVal mlast As long, _
    ByVal k As long, _
    ByVal l As long, _
    ByRef x As double, _
    ByVal xmin As double, _
    ByVal xmax As double, _
    ByVal y As double, _
    ByVal ymin As double, _
    ByVal ymax As double, _
    ByRef ff As double, _
    ByRef a As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef w As double, _
    ByRef point As long, _
    ByRef dl As double, _
    ByVal eps As double, _
    ByRef sigma As double, _
    ByRef rank As long, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02dcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal start As Nag_Start, _
    ByVal mx As long, _
    ByRef x As double, _
    ByVal my As long, _
    ByRef y As double, _
    ByRef f As double, _
    ByVal s As double, _
    ByVal nxest As long, _
    ByVal nyest As long, _
    ByRef fp As double, _
    ByRef warmstartinf As Nag_Comm, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02ddc Lib "CLW6I26DE_nag.dll" ( _
    ByVal start As Nag_Start, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef weights As double, _
    ByVal s As double, _
    ByVal nxest As long, _
    ByVal nyest As long, _
    ByRef fp As double, _
    ByRef rank As long, _
    ByRef warmstartinf As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02dec Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ff As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02dfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ff As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02dhc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mx As long, _
    ByVal my As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal nux As long, _
    ByVal nuy As long, _
    ByRef z As double, _
    ByRef spline As Nag_2dSpline, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02gac Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal nplus2 As long, _
    ByVal toler As double, _
    ByRef x As double, _
    ByRef resid As double, _
    ByRef rank As long, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02gcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal tol As double, _
    ByRef relerr As double, _
    ByRef x As double, _
    ByRef resmax As double, _
    ByRef rank As long, _
    ByRef iter As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02jdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByVal lsminp As long, _
    ByVal lsmaxp As long, _
    ByVal nxcels As long, _
    ByVal nycels As long, _
    ByVal lcoefs As long, _
    ByRef coefs As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02jec Lib "CLW6I26DE_nag.dll" ( _
    ByVal nevalv As long, _
    ByRef xevalv As double, _
    ByRef yevalv As double, _
    ByRef coefs As double, _
    ByRef fevalv As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02jfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nxeval As long, _
    ByVal nyeval As long, _
    ByRef xevalm As double, _
    ByRef yevalm As double, _
    ByRef coefs As double, _
    ByRef fevalm As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02rac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ia As long, _
    ByVal ib As long, _
    ByRef c As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02rbc Lib "CLW6I26DE_nag.dll" ( _
    ByRef a As double, _
    ByVal ia As long, _
    ByRef b As double, _
    ByVal ib As long, _
    ByVal x As double, _
    ByRef ans As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02zac Lib "CLW6I26DE_nag.dll" ( _
    ByVal px As long, _
    ByVal py As long, _
    ByRef lamda As double, _
    ByRef mu As double, _
    ByVal m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef point As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02zkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e02zlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


' chapter e04

' skeleton code for callback function
'  Sub e04abc_funct( _
'      ByVal xc As double, _
'      ByRef fc As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal funct As longPtr, _
    ByVal e1 As double, _
    ByVal e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal max_fun As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04bbc_funct( _
'      ByVal xc As double, _
'      ByRef fc As double, _
'      ByRef gc As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04bbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal funct As longPtr, _
    ByVal e1 As double, _
    ByVal e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByVal max_fun As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E04CBK Lib "CLW6I26DE_nag.dll" ( _
    ByVal fmin As double, _
    ByVal fmax As double, _
    ByVal sim_rptr As longPtr, _
    ByVal n As long, _
    ByVal ncall As long, _
    ByVal serror As double, _
    ByVal vratio As double, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub e04cbc_funct( _
'      ByVal n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e04cbc_monit( _
'      ByVal fmin As double, _
'      ByVal fmax As double, _
'      ByVal sim_rptr As longPtr, _
'      ByVal n As long, _
'      ByVal ncall As long, _
'      ByVal serror As double, _
'      ByVal vratio As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e04cbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByVal tolf As double, _
    ByVal tolx As double, _
    ByVal funct As longPtr, _
    ByVal monit As longPtr, _
    ByVal maxcal As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04dgc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04dgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04fcc_lsqfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04fcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal lsqfun As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04gbc_lsqfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByVal tdfjac As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04gbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal lsqfun As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04hcc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04hcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04hdc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e04hdc_hessfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal h_rptr As longPtr, _
'      ByVal hd_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04hdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal hessfun As longPtr, _
    ByRef x As double, _
    ByRef g As double, _
    ByRef hesl As double, _
    ByRef hesd As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E04JCP Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal nf As long, _
    ByVal x_rptr As longPtr, _
    ByVal f As double, _
    ByVal rho As double, _
    ByRef comm As Nag_Comm, _
    ByRef inform As long _
  )

' skeleton code for callback function
'  Sub e04jcc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef f As double, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e04jcc_monfun( _
'      ByVal n As long, _
'      ByVal nf As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f As double, _
'      ByVal rho As double, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e04jcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal objfun As longPtr, _
    ByVal n As long, _
    ByVal npt As long, _
    ByRef x As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal rhobeg As double, _
    ByVal rhoend As double, _
    ByVal monfun As longPtr, _
    ByVal maxcal As long, _
    ByRef f As double, _
    ByRef nf As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04kbc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04kbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal bound As Nag_BoundType, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04lbc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e04lbc_hessfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal h_rptr As longPtr, _
'      ByVal hd_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04lbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal hessfun As longPtr, _
    ByVal bound As Nag_BoundType, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04mfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal nclin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef cvec As double, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04mwc Lib "CLW6I26DE_nag.dll" ( _
    ByVal fileid As long, ByVal n As long, ByVal m As long, _
    ByVal nnzc As long, ByVal nnza As long, ByVal ncolh As long, _
    ByVal nnzh As long, ByVal lintvar As long, ByRef idxc As long, _
    ByRef c As double, ByVal iobj As long, ByRef a As double, _
    ByRef irowa As long, ByRef iccola As long, ByRef bl As double, _
    ByRef bu As double, ByVal pnames As String, ByVal crname As String, _
    ByRef h As double, ByRef irowh As long, ByRef iccolh As long, _
    ByVal minmax As long, ByRef intvar As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04mxc Lib "CLW6I26DE_nag.dll" ( _
    ByVal fileid As long, ByVal maxn As long, ByVal maxm As long, _
    ByVal maxnnz As long, ByVal maxncolh As long, ByVal maxnnzh As long, _
    ByVal maxlintvar As long, ByVal mpslst As long, ByRef n As long, _
    ByRef m As long, ByRef nnz As long, ByRef ncolh As long, _
    ByRef nnzh As long, ByRef lintvar As long, ByRef iobj As long, _
    ByRef a As double, ByRef irowa As long, ByRef iccola As long, _
    ByRef bl As double, ByRef bu As double, ByVal pnames As String, _
    ByRef nname As long, ByVal crname As String, ByRef h As double, _
    ByRef irowh As long, ByRef iccolh As long, ByRef minmax As long, _
    ByRef intvar As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04myc Lib "CLW6I26DE_nag.dll" ( _
    ByRef aptr As longPtr, _
    ByRef haptr As longPtr, _
    ByRef kaptr As longPtr, _
    ByRef blptr As longPtr, _
    ByRef buptr As longPtr, _
    ByRef xsptr As longPtr _
   )


   Declare Ptrsafe Sub e04mzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mps_fileptr As longPtr, _
    ByRef n As long, _
    ByRef m As long, _
    ByRef nnz As long, _
    ByRef iobj As long, _
    ByRef aptr As longPtr, _
    ByRef haptr As longPtr, _
    ByRef kaptr As longPtr, _
    ByRef blptr As longPtr, _
    ByRef buptr As longPtr, _
    ByRef xsptr As longPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04ncc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal nclin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef cvec As double, _
    ByRef b As double, _
    ByRef h As double, _
    ByVal tdh As long, _
    ByRef kx As long, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04nfc_qphess( _
'      ByVal n As long, _
'      ByVal jthcol As long, _
'      ByVal h_rptr As longPtr, _
'      ByVal tdh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04nfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal nclin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef cvec As double, _
    ByRef h As double, _
    ByVal tdh As long, _
    ByVal qphess As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04nkc_qphx( _
'      ByVal ncolh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04nkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal m As long, _
    ByVal nnz As long, _
    ByVal iobj As long, _
    ByVal ncolh As long, _
    ByVal qphx As longPtr, _
    ByRef a As double, _
    ByRef ha As long, _
    ByRef ka As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef xs As double, _
    ByRef ninf As long, _
    ByRef sinf As double, _
    ByRef obj As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04npc Lib "CLW6I26DE_nag.dll" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E04NSH Lib "CLW6I26DE_nag.dll" ( _
    ByVal ncolh As long, _
    ByVal x_rptr As longPtr, _
    ByVal hx_rptr As longPtr, _
    ByVal nstate As long, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub e04nqc_qphx( _
'      ByVal ncolh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e04nqc Lib "CLW6I26DE_nag.dll" ( _
    ByVal start As Nag_Start, ByVal qphx As longPtr, _
    ByVal m As long, _
    ByVal n As long, ByVal ne As long, ByVal nname As long, _
    ByVal lenc As long, ByVal ncolh As long, ByVal iobj As long, _
    ByVal objadd As double, ByVal prob As String, ByRef acol As double, _
    ByRef inda As long, ByRef loca As long, ByRef bl As double, _
    ByRef bu As double, ByRef c As double, ByRef names As longPtr, _
    ByRef helast As long, ByRef hs As long, ByRef x As double, _
    ByRef pi As double, ByRef rc As double, ByRef ns As long, _
    ByRef ninf As long, ByRef sinf As double, ByRef obj As double, _
    ByRef state As Nag_E04State, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04nrc Lib "CLW6I26DE_nag.dll" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04nsc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04ntc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04nuc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04nxc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04nyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04pcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal itype As Nag_RegularizedType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByRef b As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal tol As double, _
    ByRef x As double, _
    ByRef rnorm As double, _
    ByRef nfree As long, _
    ByRef w As double, _
    ByRef indx As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rac Lib "CLW6I26DE_nag.dll" ( _
    ByRef handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal infile As long, _
    ByVal maxnvar As long, _
    ByVal maxnblk As long, _
    ByVal maxnnz As long, _
    ByVal filelst As long, _
    ByRef nvar As long, _
    ByRef nblk As long, _
    ByRef nnz As long, _
    ByRef cvec As double, _
    ByRef nnza As long, _
    ByRef irowa As long, _
    ByRef icola As long, _
    ByRef a As double, _
    ByRef blksizea As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rec Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef cvec As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nnzc As long, _
    ByRef idxc As long, _
    ByRef c As double, _
    ByVal nnzh As long, _
    ByRef irowh As long, _
    ByRef icolh As long, _
    ByRef h As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nnzfd As long, _
    ByRef idxfd As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rhc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nclin As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal nnzb As long, _
    ByRef irowb As long, _
    ByRef icolb As long, _
    ByRef b As double, _
    ByRef idlc As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal ncnln As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal nnzgd As long, _
    ByRef irowgd As long, _
    ByRef icolgd As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal idf As long, _
    ByVal nnzh As long, _
    ByRef irowh As long, _
    ByRef icolh As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rnc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByVal dima As long, _
    ByRef nnza As long, _
    ByVal nnzasum As long, _
    ByRef irowa As long, _
    ByRef icola As long, _
    ByRef a As double, _
    ByVal nblk As long, _
    ByRef blksizea As long, _
    ByRef idblk As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rpc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nq As long, _
    ByRef qi As long, _
    ByRef qj As long, _
    ByVal dimq As long, _
    ByRef nnzq As long, _
    ByVal nnzqsum As long, _
    ByRef irowq As long, _
    ByRef icolq As long, _
    ByRef q As double, _
    ByRef idblk As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04ryc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal fileid As long, _
    ByVal cmdstr As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04rzc Lib "CLW6I26DE_nag.dll" ( _
    ByRef handleptr As longPtr, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E04STV Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef fx As double, _
    ByRef inform As long, _
    ByRef comm As Nag_Comm _
  )

   Declare Ptrsafe Sub E04STW Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvar As long, _
    ByVal x_rptr As longPtr, _
    ByVal nnzfd As long, _
    ByVal fdx_rptr As longPtr, _
    ByRef inform As long, _
    ByRef comm As Nag_Comm _
  )

   Declare Ptrsafe Sub E04STX Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvar As long, _
    ByVal x_rptr As longPtr, _
    ByVal ncnln As long, _
    ByVal gx_rptr As longPtr, _
    ByRef inform As long, _
    ByRef comm As Nag_Comm _
  )

   Declare Ptrsafe Sub E04STY Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvar As long, _
    ByVal x_rptr As longPtr, _
    ByVal nnzgd As long, _
    ByVal gdx_rptr As longPtr, _
    ByRef inform As long, _
    ByRef comm As Nag_Comm _
  )

   Declare Ptrsafe Sub E04STZ Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvar As long, _
    ByVal x_rptr As longPtr, _
    ByVal ncnln As long, _
    ByVal idf As long, _
    ByVal sigma As double, _
    ByVal lambda_rptr As longPtr, _
    ByVal nnzh As long, _
    ByVal hx_rptr As longPtr, _
    ByRef inform As long, _
    ByRef comm As Nag_Comm _
  )

   Declare Ptrsafe Sub E04STU Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvar As long, _
    ByVal x_rptr As longPtr, _
    ByVal nnzu As long, _
    ByVal u_rptr As longPtr, _
    ByRef inform As long, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub e04stc_objfun( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef fx As double, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e04stc_objgrd( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal nnzfd As long, _
'      ByVal fdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e04stc_confun( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal ncnln As long, _
'      ByVal gx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e04stc_congrd( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal nnzgd As long, _
'      ByVal gdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e04stc_hess( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal ncnln As long, _
'      ByVal idf As long, _
'      ByVal sigma As double, _
'      ByVal lambda_rptr As longPtr, _
'      ByVal nnzh As long, _
'      ByVal hx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e04stc_mon( _
'      ByVal nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal nnzu As long, _
'      ByVal u_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e04stc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal objfun As longPtr, _
    ByVal objgrd As longPtr, _
    ByVal confun As longPtr, _
    ByVal congrd As longPtr, _
    ByVal hess As longPtr, _
    ByVal mon As longPtr, _
    ByVal nvar As long, _
    ByRef x As double, _
    ByVal nnzu As long, _
    ByRef u As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04svc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal nvar As long, _
    ByRef x As double, _
    ByVal nnzu As long, _
    ByRef u As double, _
    ByVal nnzuc As long, _
    ByRef uc As double, _
    ByVal nnzua As long, _
    ByRef ua As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef inform As long, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04ucc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e04ucc_confun( _
'      ByVal n As long, _
'      ByVal ncnlin As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal conf_rptr As longPtr, _
'      ByVal conjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04ucc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal nclin As long, _
    ByVal ncnlin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal objfun As longPtr, _
    ByVal confun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04udc Lib "CLW6I26DE_nag.dll" ( _
    ByVal fileid As long, _
    ByRef lwsav As Nag_Boolean, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As NagError _
   )


   Declare Ptrsafe Sub e04uec Lib "CLW6I26DE_nag.dll" ( _
    ByVal str As String, _
    ByRef lwsav As Nag_Boolean, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As NagError _
   )


   Declare Ptrsafe Sub e04ufc Lib "CLW6I26DE_nag.dll" ( _
    ByRef irevcm As long, ByVal n As long, ByVal nclin As long, _
    ByVal ncnln As long, ByVal tda As long, ByVal tdcj As long, _
    ByVal tdr As long, ByRef a As double, ByRef bl As double, _
    ByRef bu As double, ByRef iter As long, ByRef istate As long, _
    ByRef c As double, ByRef cjac As double, ByRef clamda As double, _
    ByRef objf As double, ByRef objgrd As double, ByRef r As double, _
    ByRef x As double, ByRef needc As long, ByRef iwork As long, _
    ByVal liwork As long, ByRef work As double, ByVal lwork As long, _
    ByVal cwsav As String, ByRef lwsav As Nag_Boolean, ByRef iwsav As long, _
    ByRef rwsav As double, ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04ugc_confun( _
'      ByVal ncnln As long, _
'      ByVal njnln As long, _
'      ByVal nnzjac As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal conf_rptr As longPtr, _
'      ByVal conjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e04ugc_objfun( _
'      ByVal nonln As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrad_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04ugc Lib "CLW6I26DE_nag.dll" ( _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByVal n As long, _
    ByVal m As long, ByVal ncnln As long, ByVal nonln As long, _
    ByVal njnln As long, ByVal iobj As long, ByVal nnz As long, _
    ByRef a As double, ByRef ha As long, ByRef ka As long, _
    ByRef bl As double, ByRef bu As double, ByRef xs As double, _
    ByRef ninf As long, ByRef sinf As double, ByRef objf As double, _
    ByRef comm As Nag_Comm, ByRef ops As Nag_E04_Opt, ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04unc_objfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByVal tdfjac As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e04unc_confun( _
'      ByVal n As long, _
'      ByVal ncnlin As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal conf_rptr As longPtr, _
'      ByVal conjac_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04unc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal nclin As long, _
    ByVal ncnlin As long, _
    ByRef a As double, _
    ByVal tda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef y As double, _
    ByVal objfun As longPtr, _
    ByVal confun As longPtr, _
    ByRef x As double, _
    ByRef objf As double, _
    ByRef f As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04vgc Lib "CLW6I26DE_nag.dll" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04vhc_usrfun( _
'      ByRef status As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal needf As long, _
'      ByVal nf As long, _
'      ByVal f_rptr As longPtr, _
'      ByVal needg As long, _
'      ByVal leng As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04vhc Lib "CLW6I26DE_nag.dll" ( _
    ByVal start As Nag_Start, ByVal nf As long, ByVal n As long, _
    ByVal nxname As long, ByVal nfname As long, ByVal objadd As double, _
    ByRef objrow As long, ByVal prob As String, ByVal usrfun As longPtr, _
    ByRef iafun As long, ByRef javar As long, ByRef a As double, _
    ByVal lena As long, ByVal nea As long, ByRef igfun As long, _
    ByRef jgvar As long, ByVal leng As long, ByVal neg As long, _
    ByRef xlow As double, ByRef xupp As double, ByRef xnames As longPtr, _
    ByRef flow As double, ByRef fupp As double, ByRef fnames As longPtr, _
    ByRef x As double, ByRef xstate As long, ByRef xmul As double, _
    ByRef f As double, ByRef fstate As long, ByRef fmul As double, _
    ByRef ns As long, ByRef ninf As long, ByRef sinf As double, _
    ByRef state As Nag_E04State, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04vjc_usrfun( _
'      ByRef status As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal needf As long, _
'      ByVal nf As long, _
'      ByVal f_rptr As longPtr, _
'      ByVal needg As long, _
'      ByVal leng As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04vjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nf As long, ByVal n As long, ByVal usrfun As longPtr, _
    ByRef iafun As long, ByRef javar As long, ByRef a As double, _
    ByVal lena As long, ByRef nea As long, ByRef igfun As long, _
    ByRef jgvar As long, ByVal leng As long, ByRef neg As long, _
    ByRef x As double, ByRef xlow As double, ByRef xupp As double, _
    ByRef state As Nag_E04State, _
    ByRef comm As Nag_Comm, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04vkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04vlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04vmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04vnc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04vrc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04vsc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04wbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal rname As String, _
    ByVal cwsav As String, _
    ByVal lcwsav As long, _
    ByRef lwsav As Nag_Boolean, _
    ByVal llwsav As long, _
    ByRef iwsav As long, _
    ByVal liwsav As long, _
    ByRef rwsav As double, _
    ByVal lrwsav As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04wcc Lib "CLW6I26DE_nag.dll" ( _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E04WDP Lib "CLW6I26DE_nag.dll" ( _
    ByRef mode As long, _
    ByVal ncnln As long, _
    ByVal n As long, _
    ByVal tdcj As long, _
    ByVal needc_iptr As longPtr, _
    ByVal x_rptr As longPtr, _
    ByVal ccon_rptr As longPtr, _
    ByVal cjac_rptr As longPtr, _
    ByVal nstate As long, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub e04wdc_confun( _
'      ByRef mode As long, _
'      ByVal ncnln As long, _
'      ByVal n As long, _
'      ByVal tdcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal ccon_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e04wdc_objfun( _
'      ByRef mode As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal grad_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04wdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal nclin As long, ByVal ncnln As long, _
    ByVal tda As long, ByVal tdcj As long, ByVal tdh As long, _
    ByRef a As double, ByRef bl As double, ByRef bu As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef majits As long, _
    ByRef istate As long, ByRef ccon As double, ByRef cjac As double, _
    ByRef clamda As double, ByRef objf As double, ByRef grad As double, _
    ByRef h As double, ByRef x As double, ByRef state As Nag_E04State, ByRef comm As Nag_Comm, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04wec Lib "CLW6I26DE_nag.dll" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04wfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04wgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04whc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04wkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04wlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal st As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E04State, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04xac_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04xac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByVal objfun As longPtr, _
    ByRef objf As double, _
    ByRef g As double, _
    ByRef h_forward As double, _
    ByRef h_central As double, _
    ByRef hess As double, _
    ByVal tdhess As long, _
    ByRef deriv_info As Nag_DerivInfo, _
    ByRef ops As Nag_E04_Opt, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04xxc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ops As Nag_E04_Opt _
   )


   Declare Ptrsafe Sub e04xyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nmptr As longPtr, _
    ByVal opt_fileptr As longPtr, _
    ByRef ops As Nag_E04_Opt, _
    ByVal dnprint As Nag_Boolean, _
    ByVal outfileptr As longPtr, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04xzc Lib "CLW6I26DE_nag.dll" ( _
    ByRef ops As Nag_E04_Opt, _
    ByVal p_nameptr As longPtr, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub e04yac_lsqfun( _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByVal tdfjac As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub e04yac Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, _
    ByVal n As long, _
    ByVal lsqfun As longPtr, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByVal tdfjac As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04ycc Lib "CLW6I26DE_nag.dll" ( _
    ByVal job As long, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal fsumsq As double, _
    ByRef cj As double, _
    ByRef ops As Nag_E04_Opt, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04zmc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal optstr As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04znc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e04zpc Lib "CLW6I26DE_nag.dll" ( _
    ByVal handleptr As longPtr, _
    ByVal fileid As long, _
    ByRef fail As NagError _
   )


' chapter e05

   Declare Ptrsafe Sub e05jac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n_r As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E05JBK Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal ncall As long, _
    ByVal xbest_rptr As longPtr, _
    ByVal icount_iptr As longPtr, _
    ByVal ninit As long, _
    ByVal list_rptr As longPtr, _
    ByVal numpts_iptr As longPtr, _
    ByVal initpt_iptr As longPtr, _
    ByVal nbaskt As long, _
    ByVal xbaskt_rptr As longPtr, _
    ByVal boxl_rptr As longPtr, _
    ByVal boxu_rptr As longPtr, _
    ByVal nstate As long, _
    ByRef comm As Nag_Comm, _
    ByRef inform As long _
  )

' skeleton code for callback function
'  Sub e05jbc_objfun( _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef f As double, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e05jbc_monit( _
'      ByVal n As long, _
'      ByVal ncall As long, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal icount_iptr As longPtr, _
'      ByVal ninit As long, _
'      ByVal list_rptr As longPtr, _
'      ByVal numpts_iptr As longPtr, _
'      ByVal initpt_iptr As longPtr, _
'      ByVal nbaskt As long, _
'      ByVal xbaskt_rptr As longPtr, _
'      ByVal boxl_rptr As longPtr, _
'      ByVal boxu_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e05jbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal objfun As longPtr, _
    ByVal bound As Nag_BoundType, _
    ByVal initmethod As Nag_MCSInitMethod, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal sdlist As long, _
    ByRef list As double, _
    ByRef numpts As long, _
    ByRef initpt As long, _
    ByVal monit As longPtr, _
    ByRef x As double, _
    ByRef obj As double, _
    ByRef state As Nag_E05State, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05jcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal fileid As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05jdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05jec Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByVal cvalue As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05jfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByVal ivalue As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05jgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByVal rvalue As double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function e05jhc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   ) As long


   Declare Ptrsafe Sub e05jkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05jlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef rvalue As double, _
    ByRef state As Nag_E05State, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E05SXM Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal npar As long, _
    ByVal x_rptr As longPtr, _
    ByVal xb_rptr As longPtr, _
    ByVal fb As double, _
    ByVal xbest_rptr As longPtr, _
    ByVal fbest_rptr As longPtr, _
    ByVal itt_iptr As longPtr, _
    ByRef comm As Nag_Comm, _
    ByRef inform As long _
  )

' skeleton code for callback function
'  Sub e05sac_objfun( _
'      ByRef mode As long, _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal vecout_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e05sac_monmod( _
'      ByVal ndim As long, _
'      ByVal npar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xb_rptr As longPtr, _
'      ByVal fb As double, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal fbest_rptr As longPtr, _
'      ByVal itt_iptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e05sac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal npar As long, _
    ByRef xb As double, _
    ByRef fb As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal objfun As longPtr, _
    ByVal monmod As longPtr, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef comm As Nag_Comm, _
    ByRef itt As long, _
    ByRef inform As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E05SZM Lib "CLW6I26DE_nag.dll" ( _
    ByRef mode As long, _
    ByVal ncon As long, _
    ByVal ndim As long, _
    ByVal tdcj As long, _
    ByVal needc_iptr As longPtr, _
    ByVal x_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal cjac_rptr As longPtr, _
    ByVal nstate As long, _
    ByRef comm As Nag_Comm _
  )

   Declare Ptrsafe Sub E05SYM Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal ncon As long, _
    ByVal npar As long, _
    ByVal x_rptr As longPtr, _
    ByVal xb_rptr As longPtr, _
    ByVal fb As double, _
    ByVal cb_rptr As longPtr, _
    ByVal xbest_rptr As longPtr, _
    ByVal fbest_rptr As longPtr, _
    ByVal cbest_rptr As longPtr, _
    ByVal itt_iptr As longPtr, _
    ByRef comm As Nag_Comm, _
    ByRef inform As long _
  )

' skeleton code for callback function
'  Sub e05sbc_objfun( _
'      ByRef mode As long, _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal vecout_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e05sbc_confun( _
'      ByRef mode As long, _
'      ByVal ncon As long, _
'      ByVal ndim As long, _
'      ByVal tdcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e05sbc_monmod( _
'      ByVal ndim As long, _
'      ByVal ncon As long, _
'      ByVal npar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xb_rptr As longPtr, _
'      ByVal fb As double, _
'      ByVal cb_rptr As longPtr, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal fbest_rptr As longPtr, _
'      ByVal cbest_rptr As longPtr, _
'      ByVal itt_iptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e05sbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, ByVal ncon As long, ByVal npar As long, _
    ByRef xb As double, ByRef fb As double, ByRef cb As double, _
    ByRef bl As double, ByRef bu As double, ByRef xbest As double, _
    ByRef fbest As double, ByRef cbest As double, ByVal objfun As longPtr, _
    ByVal confun As longPtr, _
    ByVal monmod As longPtr, ByRef iopts As long, _
    ByRef opts As double, ByRef comm As Nag_Comm, _
    ByRef itt As long, ByRef inform As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub E04UDM Lib "CLW6I26DE_nag.dll" ( _
    ByRef mode As long, _
    ByVal ncnln As long, _
    ByVal n As long, _
    ByVal tdcjsl As long, _
    ByVal needc_iptr As longPtr, _
    ByVal x_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal cjsl_rptr As longPtr, _
    ByVal nstate As long, _
    ByRef comm As Nag_Comm _
  )

   Declare Ptrsafe Sub E05UCZ Lib "CLW6I26DE_nag.dll" ( _
    ByVal npts As long, _
    ByVal quas_rptr As longPtr, _
    ByVal n As long, _
    ByVal repeat As Nag_Boolean, _
    ByVal bl_rptr As longPtr, _
    ByVal bu_rptr As longPtr, _
    ByRef comm As Nag_Comm, _
    ByRef mode As long _
  )

' skeleton code for callback function
'  Sub e05ucc_confun( _
'      ByRef mode As long, _
'      ByVal ncnln As long, _
'      ByVal n As long, _
'      ByVal tdcjsl As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjsl_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e05ucc_objfun( _
'      ByRef mode As long, _
'      ByVal n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e05ucc_start( _
'      ByVal npts As long, _
'      ByVal quas_rptr As longPtr, _
'      ByVal n As long, _
'      ByVal repeat As Nag_Boolean, _
'      ByVal bl_rptr As longPtr, _
'      ByVal bu_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef mode As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e05ucc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, ByVal nclin As long, ByVal ncnln As long, _
    ByRef a As double, ByVal tda As long, ByRef bl As double, _
    ByRef bu As double, ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByVal npts As long, ByRef x As double, ByVal ldx As long, _
    ByVal start As longPtr, _
    ByVal repeat As Nag_Boolean, ByVal nb As long, _
    ByRef objf As double, ByRef objgrd As double, ByVal ldobjgrd As long, _
    ByRef iter As long, ByRef c As double, ByVal ldc As long, _
    ByRef cjac As double, ByVal ldcjac As long, ByVal sdcjac As long, _
    ByRef r As double, ByVal ldr As long, ByVal sdr As long, _
    ByRef clamda As double, ByVal ldclamda As long, ByRef istate As long, _
    ByVal ldistate As long, ByRef iopts As long, ByRef opts As double, ByRef comm As Nag_Comm, ByRef info As long, _
    ByRef fail As NagError _
   )




' skeleton code for callback function
'  Sub e05usc_confun( _
'      ByRef mode As long, _
'      ByVal ncnln As long, _
'      ByVal n As long, _
'      ByVal pdcjsl As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjsl_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub e05usc_objfun( _
'      ByRef mode As long, _
'      ByVal m As long, _
'      ByVal n As long, _
'      ByVal pdfjsl As long, _
'      ByVal needfi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjsl_rptr As longPtr, _
'      ByVal nstate As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub e05usc_start( _
'      ByVal npts As long, _
'      ByVal quas_rptr As longPtr, _
'      ByVal n As long, _
'      ByVal repeat1 As Nag_Boolean, _
'      ByVal bl_rptr As longPtr, _
'      ByVal bu_rptr As longPtr, _
'      ByRef comm As Nag_Comm, _
'      ByRef mode As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub e05usc Lib "CLW6I26DE_nag.dll" ( _
    ByVal m As long, ByVal n As long, ByVal nclin As long, _
    ByVal ncnln As long, ByRef a As double, ByVal pda As long, _
    ByRef bl As double, ByRef bu As double, ByRef y As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByVal npts As long, _
    ByRef x As double, ByVal pdx As long, ByVal start As longPtr, _
    ByVal repeat1 As Nag_Boolean, ByVal nb As long, ByRef objf As double, _
    ByRef f As double, ByRef fjac As double, ByVal ldfjac As long, _
    ByVal sdfjac As long, ByRef iter As long, ByRef c As double, _
    ByVal pdc As long, ByRef cjac As double, ByVal ldcjac As long, _
    ByVal sdcjac As long, ByRef clamda As double, ByVal pdclamda As long, _
    ByRef istate As long, ByVal pdistate As long, ByRef iopts As long, _
    ByRef opts As double, ByRef comm As Nag_Comm, _
    ByRef info As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05zkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub e05zlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


