

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter m01
   Declare Ptrsafe Sub nag_double_sort Lib "CLW6I26DE_nag.dll" Alias "m01cac" ( _
    ByRef vec As double, _
    ByVal n As long, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_quicksort_compare( _
'      ByVal a As longPtr, _
'      ByVal b As longPtr _
'    ) As long
'      ' your code here
'  End Function

   Declare Ptrsafe Sub nag_quicksort Lib "CLW6I26DE_nag.dll" Alias "m01csc" ( _
    ByRef vec As longPtr, _
    ByVal n As long, _
    ByVal size As long, _
    ByVal stride As longPtr, _
    ByVal compare As longPtr, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_stable_sort_compare( _
'      ByVal a As longPtr, _
'      ByVal b As longPtr _
'    ) As long
'      ' your code here
'  End Function

   Declare Ptrsafe Sub nag_stable_sort Lib "CLW6I26DE_nag.dll" Alias "m01ctc" ( _
    ByRef vec As longPtr, _
    ByVal n As long, _
    ByVal size As long, _
    ByVal stride As longPtr, _
    ByVal compare As longPtr, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_chain_sort_compare( _
'      ByVal a As longPtr, _
'      ByVal b As longPtr _
'    ) As long
'      ' your code here
'  End Function

   Declare Ptrsafe Sub nag_chain_sort Lib "CLW6I26DE_nag.dll" Alias "m01cuc" ( _
    ByRef baseptr As longPtr, _
    ByVal offset As longPtr, _
    ByVal compare As longPtr, _
    ByVal order As Nag_SortOrder, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_rank_sort_compare( _
'      ByVal a As longPtr, _
'      ByVal b As longPtr _
'    ) As long
'      ' your code here
'  End Function

   Declare Ptrsafe Sub nag_rank_sort Lib "CLW6I26DE_nag.dll" Alias "m01dsc" ( _
    ByRef vec As longPtr, _
    ByVal n As long, _
    ByVal stride As longPtr, _
    ByVal compare As longPtr, _
    ByVal order As Nag_SortOrder, _
    ByRef ranks As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_reorder_vector Lib "CLW6I26DE_nag.dll" Alias "m01esc" ( _
    ByRef vec As longPtr, _
    ByVal n As long, _
    ByVal size As long, _
    ByVal stride As longPtr, _
    ByRef indices As long, _
    ByRef fail As NagError _
   )

' skeleton code for callback function
'  Function nag_search_vector_compare( _
'      ByVal a As longPtr, _
'      ByVal b As longPtr _
'    ) As long
'      ' your code here
'  End Function

   Declare Ptrsafe Function nag_search_vector Lib "CLW6I26DE_nag.dll" Alias "m01fsc" ( _
    ByVal keyptr As longPtr, _
    ByRef vec As longPtr, _
    ByVal n As long, _
    ByVal stride As longPtr, _
    ByVal compare As longPtr, _
    ByVal order As Nag_SortOrder, _
    ByVal final As Nag_SearchMatch, _
    ByRef matchptr As longPtr, _
    ByRef fail As NagError _
   ) As long

   Declare Ptrsafe Function nag_search_double Lib "CLW6I26DE_nag.dll" Alias "m01nac" ( _
    ByVal validate As Nag_Boolean, _
    ByRef rv As double, _
    ByVal m1 As long, _
    ByVal m2 As long, _
    ByVal item As double, _
    ByRef fail As NagError _
   ) As long

   Declare Ptrsafe Function nag_search_int Lib "CLW6I26DE_nag.dll" Alias "m01nbc" ( _
    ByVal validate As Nag_Boolean, _
    ByRef iv As long, _
    ByVal m1 As long, _
    ByVal m2 As long, _
    ByVal item As long, _
    ByRef fail As NagError _
   ) As long

   Declare Ptrsafe Function nag_search_char Lib "CLW6I26DE_nag.dll" Alias "m01ncc" ( _
    ByVal validate As Nag_Boolean, _
    ByRef ch As longPtr, _
    ByVal m1 As long, _
    ByVal m2 As long, _
    ByVal item As String, _
    ByRef fail As NagError _
   ) As long

   Declare Ptrsafe Sub nag_make_indices Lib "CLW6I26DE_nag.dll" Alias "m01zac" ( _
    ByRef ranks As long, _
    ByVal n As long, _
    ByRef fail As NagError _
   )

