

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter x01

' chapter x02
   Declare Ptrsafe Function nag_max_sine_argument Lib "CLW6I26DE_nag.dll" Alias "x02ahc" ( _
   ) As double

   Declare Ptrsafe Function nag_machine_precision Lib "CLW6I26DE_nag.dll" Alias "x02ajc" ( _
   ) As double

   Declare Ptrsafe Function nag_real_smallest_number Lib "CLW6I26DE_nag.dll" Alias "x02akc" ( _
   ) As double

   Declare Ptrsafe Function nag_real_largest_number Lib "CLW6I26DE_nag.dll" Alias "x02alc" ( _
   ) As double

   Declare Ptrsafe Function nag_real_safe_small_number Lib "CLW6I26DE_nag.dll" Alias "x02amc" ( _
   ) As double

   Declare Ptrsafe Function nag_complex_safe_small_number Lib "CLW6I26DE_nag.dll" Alias "x02anc" ( _
   ) As double

   Declare Ptrsafe Function nag_real_max_exponent Lib "CLW6I26DE_nag.dll" Alias "x02blc" ( _
   ) As long


' chapter x03

' chapter x04
   Declare Ptrsafe Sub nag_open_file Lib "CLW6I26DE_nag.dll" Alias "x04acc" ( _
    ByVal filename As String, _
    ByVal mode As long, _
    ByRef fileid As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_close_file Lib "CLW6I26DE_nag.dll" Alias "x04adc" ( _
    ByVal fileid As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_write_line Lib "CLW6I26DE_nag.dll" Alias "x04bac" ( _
    ByVal fileid As long, _
    ByVal line As String _
   )

   Declare Ptrsafe Sub nag_read_line Lib "CLW6I26DE_nag.dll" Alias "x04bbc" ( _
    ByVal fileid As long, _
    ByVal ln As String, _
    ByVal linelen As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_gen_real_mat_print Lib "CLW6I26DE_nag.dll" Alias "x04cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_gen_real_mat_print_comp Lib "CLW6I26DE_nag.dll" Alias "x04cbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As long, _
    ByVal indent As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_pack_real_mat_print Lib "CLW6I26DE_nag.dll" Alias "x04ccc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_pack_real_mat_print_comp Lib "CLW6I26DE_nag.dll" Alias "x04cdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As long, _
    ByRef a As double, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As long, _
    ByVal indent As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_band_real_mat_print Lib "CLW6I26DE_nag.dll" Alias "x04cec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal kl As long, _
    ByVal ku As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_band_real_mat_print_comp Lib "CLW6I26DE_nag.dll" Alias "x04cfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal kl As long, _
    ByVal ku As long, _
    ByRef a As double, _
    ByVal pda As long, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As long, _
    ByVal indent As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_gen_complx_mat_print Lib "CLW6I26DE_nag.dll" Alias "x04dac" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As Complex, _
    ByVal pda As long, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_gen_complx_mat_print_comp Lib "CLW6I26DE_nag.dll" Alias "x04dbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal matrix As Nag_MatrixType, _
    ByVal diag As Nag_DiagType, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef a As Complex, _
    ByVal pda As long, _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As long, _
    ByVal indent As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_pack_complx_mat_print Lib "CLW6I26DE_nag.dll" Alias "x04dcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As long, _
    ByRef a As Complex, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_pack_complx_mat_print_comp Lib "CLW6I26DE_nag.dll" Alias "x04ddc" ( _
    ByVal order as Nag_OrderType, _
    ByVal uplo As Nag_UploType, _
    ByVal diag As Nag_DiagType, _
    ByVal n As long, _
    ByRef a As Complex, _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByRef rlabs As longPtr, _
    ByVal labcol As Nag_LabelType, _
    ByRef clabs As longPtr, _
    ByVal ncols As long, _
    ByVal indent As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_band_complx_mat_print Lib "CLW6I26DE_nag.dll" Alias "x04dec" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal kl As long, _
    ByVal ku As long, _
    ByRef a As Complex, _
    ByVal pda As long, _
    ByVal title As String, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Sub nag_band_complx_mat_print_comp Lib "CLW6I26DE_nag.dll" Alias "x04dfc" ( _
    ByVal order as Nag_OrderType, _
    ByVal m As long, _
    ByVal n As long, _
    ByVal kl As long, _
    ByVal ku As long, _
    ByRef a As Complex, _
    ByVal pda As long, _
    ByVal cmplxform As Nag_ComplexFormType, _
    ByVal form As String, _
    ByVal title As String, _
    ByVal labrow As Nag_LabelType, _
    ByVal rlabs As String, _
    ByVal labcol As Nag_LabelType, _
    ByVal clabs As String, _
    ByVal ncols As long, _
    ByVal indent As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Function nag_enum_name_to_value Lib "CLW6I26DE_nag.dll" Alias "x04nac" ( _
    ByVal enum_string As String _
   ) As long

   Declare Ptrsafe Function nag_enum_value_to_name Lib "CLW6I26DE_nag.dll" Alias "x04nbc" ( _
    ByVal enum_value As long _
   ) as String

   Declare Ptrsafe Function nag_error_name_to_code Lib "CLW6I26DE_nag.dll" Alias "x04ncc" ( _
    ByVal error_name As String _
   ) As long

   Declare Ptrsafe Function nag_code_to_error_name Lib "CLW6I26DE_nag.dll" Alias "x04ndc" ( _
    ByVal code As long _
   ) as String

   Declare Ptrsafe Function NAG_REALLOC Lib "CLW6I26DE_nag.dll" Alias "x04bcc" ( _
    ByVal ptr As longPtr, _
    ByVal newsize As long _
  ) As longPtr

   Declare Ptrsafe Sub NAG_FREE Lib "CLW6I26DE_nag.dll" Alias "x04bdc" ( _
    ByRef ptr As longPtr _
  )

   Declare Ptrsafe Function NAG_ALLOC Lib "CLW6I26DE_nag.dll" Alias "x04bjc" ( _
    ByVal size As long _
  ) As longPtr


' chapter x06
' chapter x06

   Declare Ptrsafe Sub nag_omp_set_num_threads Lib "CLW6I26DE_nag.dll" Alias "x06aac" ( _
    ByVal num As long, _
    ByRef fail As NagError _
   )

   Declare Ptrsafe Function nag_omp_get_num_threads Lib "CLW6I26DE_nag.dll" Alias "x06abc" ( _
   ) As long

   Declare Ptrsafe Function nag_omp_get_max_threads Lib "CLW6I26DE_nag.dll" Alias "x06acc" ( _
   ) As long

   Declare Ptrsafe Function nag_omp_get_thread_num Lib "CLW6I26DE_nag.dll" Alias "x06adc" ( _
   ) As long

   Declare Ptrsafe Function nag_omp_in_parallel Lib "CLW6I26DE_nag.dll" Alias "x06afc" ( _
   ) As long

   Declare Ptrsafe Sub nag_omp_set_nested Lib "CLW6I26DE_nag.dll" Alias "x06agc" ( _
    ByVal nesting As long _
   )

   Declare Ptrsafe Function nag_omp_get_nested Lib "CLW6I26DE_nag.dll" Alias "x06ahc" ( _
   ) As long

   Declare Ptrsafe Function nag_using_threaded_impl Lib "CLW6I26DE_nag.dll" Alias "x06xac" ( _
   ) As long


' chapter x07
   Declare Ptrsafe Function nag_is_finite Lib "CLW6I26DE_nag.dll" Alias "x07aac" ( _
    ByVal x As double _
   ) As long

   Declare Ptrsafe Function nag_is_nan Lib "CLW6I26DE_nag.dll" Alias "x07abc" ( _
    ByVal x As double _
   ) As long

   Declare Ptrsafe Sub nag_create_infinity Lib "CLW6I26DE_nag.dll" Alias "x07bac" ( _
    ByVal isign As long, _
    ByRef x As double _
   )

   Declare Ptrsafe Sub nag_create_nan Lib "CLW6I26DE_nag.dll" Alias "x07bbc" ( _
    ByVal quiet As long, _
    ByRef x As double _
   )

   Declare Ptrsafe Sub nag_get_ieee_exception_mode Lib "CLW6I26DE_nag.dll" Alias "x07cac" ( _
    ByRef exceptionmode As long _
   )

   Declare Ptrsafe Sub nag_set_ieee_exception_mode Lib "CLW6I26DE_nag.dll" Alias "x07cbc" ( _
    ByRef exceptionmode As long _
   )

