

' VBA7 64bit declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.
' chapter d01

' skeleton code for callback function
'  Function d01bdc_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01bdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef comm As Nag_Comm _
   )


' skeleton code for callback function
'  Function d01dac_phi1( _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d01dac_phi2( _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d01dac_f( _
'      ByVal x As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ya As double, _
    ByVal yb As double, _
    ByVal phi1 As longPtr, _
    ByVal phi2 As longPtr, _
    ByVal f As longPtr, _
    ByVal absacc As double, _
    ByRef ans As double, _
    ByRef npts As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d01esc_f( _
'      ByVal ni As long, _
'      ByVal ndim As long, _
'      ByVal nx As long, _
'      ByVal xtr As double, _
'      ByVal nntr As long, _
'      ByVal icolzp_iptr As longPtr, _
'      ByVal irowix_iptr As longPtr, _
'      ByVal xs_rptr As longPtr, _
'      ByVal qs_iptr As longPtr, _
'      ByVal fm_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d01esc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ni As long, _
    ByVal ndim As long, _
    ByVal f As longPtr, _
    ByRef maxdlv As long, _
    ByRef dinest As double, _
    ByRef errest As double, _
    ByRef ivalid As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01fbc_fun( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function d01fbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByRef nptvec As long, _
    ByVal lwa As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByVal fun As longPtr, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub D01FDV Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal x_rptr As longPtr, _
    ByVal j As long, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Function d01fdc_f( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Sub d01fdc_region( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal j As long, _
'      ByRef c As double, _
'      ByRef d As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d01fdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal f As longPtr, _
    ByVal sigma As double, _
    ByVal region As longPtr, _
    ByVal limit As long, _
    ByVal r0 As double, _
    ByVal u As double, _
    ByRef result As double, _
    ByRef ncalls As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01gac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ans As double, _
    ByRef er As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d01gdc_vecfun( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal fv_rptr As longPtr, _
'      ByVal m As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d01gdc_vecreg( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal j As long, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByVal m As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d01gdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal vecfun As longPtr, _
    ByVal vecreg As longPtr, _
    ByVal npts As long, _
    ByRef vk As double, _
    ByVal nrand As long, _
    ByVal transform As Nag_Boolean, _
    ByRef res As double, _
    ByRef err As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01gyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal npts As long, _
    ByRef vk As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01gzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal np1 As long, _
    ByVal np2 As long, _
    ByRef vk As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01pac_functn( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01pac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByRef vert As double, _
    ByVal functn As longPtr, _
    ByRef minord As long, _
    ByVal maxord As long, _
    ByRef finvls As double, _
    ByRef esterr As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01rac Lib "CLW6I26DE_nag.dll" ( _
    ByRef irevcm As long, ByVal ni As long, ByVal a As double, _
    ByVal b As double, ByRef sid As long, ByRef needi As long, _
    ByRef x As double, ByVal lenx As long, ByRef nx As long, _
    ByRef fm As double, ByVal ldfm As long, ByRef dinest As double, _
    ByRef errest As double, ByRef iopts As long, ByRef opts As double, _
    ByRef icom As long, ByVal licom As long, ByRef com As double, _
    ByVal lcom As long, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01rcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ni As long, _
    ByRef lenxrq As long, _
    ByRef ldfmrq As long, _
    ByRef sdfmrq As long, _
    ByRef licmin As long, _
    ByRef licmax As long, _
    ByRef lcmin As long, _
    ByRef lcmax As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d01rgc_f( _
'      ByVal x_rptr As longPtr, _
'      ByVal nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d01rgc Lib "CLW6I26DE_nag.dll" ( _
    ByVal a As double, _
    ByVal b As double, _
    ByVal f As longPtr, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByRef dinest As double, _
    ByRef errest As double, _
    ByRef nevals As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01sjc_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01sjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01skc_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01skc Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01slc_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01slc Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal nbrkpts As long, _
    ByRef brkpts As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01smc_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01smc Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As longPtr, _
    ByVal boundinf As Nag_BoundInterval, _
    ByVal bound As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01snc_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01snc Lib "CLW6I26DE_nag.dll" ( _
    ByVal g As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal omega As double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01spc_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01spc Lib "CLW6I26DE_nag.dll" ( _
    ByVal g As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal alfa As double, _
    ByVal beta As double, _
    ByVal wt_func As Nag_QuadWeight, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01sqc_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01sqc Lib "CLW6I26DE_nag.dll" ( _
    ByVal g As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal c As double, _
    ByVal epsabs As double, _
    ByVal epsrel As double, _
    ByVal max_num_subint As long, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qp As Nag_QuadProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01ssc_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01ssc Lib "CLW6I26DE_nag.dll" ( _
    ByVal g As longPtr, _
    ByVal a As double, _
    ByVal omega As double, _
    ByVal wt_func As Nag_TrigTransform, _
    ByVal maxintervals As long, _
    ByVal max_num_subint As long, _
    ByVal epsabs As double, _
    ByRef result As double, _
    ByRef abserr As double, _
    ByRef qpsub As Nag_QuadSubProgress, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01tac_f( _
'      ByVal x As double, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Function d01tac Lib "CLW6I26DE_nag.dll" ( _
    ByVal quadrule As Nag_GaussFormulae, _
    ByVal f As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal npts As long, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   ) As double


   Declare Ptrsafe Sub d01tbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01tcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal c As double, _
    ByVal d As double, _
    ByVal n As long, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01tdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByVal muzero As double, _
    ByRef weight As double, _
    ByRef abscis As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01tec Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef mu As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d01uac_f( _
'      ByVal x_rptr As longPtr, _
'      ByVal nx As long, _
'      ByVal fv_rptr As longPtr, _
'      ByRef iflag As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d01uac Lib "CLW6I26DE_nag.dll" ( _
    ByVal quad_type As Nag_QuadType, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByVal f As longPtr, _
    ByRef dinest As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d01ubc_fun( _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal n As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef istop As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d01ubc Lib "CLW6I26DE_nag.dll" ( _
    ByVal fun As longPtr, _
    ByVal n As long, _
    ByRef ans As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01wcc_f( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01wcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal f As longPtr, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef minpts As long, _
    ByVal maxpts As long, _
    ByVal eps As double, _
    ByRef finval As double, _
    ByRef acc As double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d01xbc_f( _
'      ByVal ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d01xbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ndim As long, _
    ByVal f As longPtr, _
    ByVal method As Nag_MCMethod, _
    ByVal cont As Nag_Start, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef mincls As long, _
    ByVal maxcls As long, _
    ByVal eps As double, _
    ByRef finest As double, _
    ByRef acc As double, _
    ByRef comm_arrptr As longPtr, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01zkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef iopts As long, _
    ByVal liopts As long, _
    ByRef opts As double, _
    ByVal lopts As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d01zlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal optstr As String, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As String, _
    ByVal lcvalue As long, _
    ByRef optype As Nag_VariableType, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef fail As NagError _
   )


' chapter d02

' skeleton code for callback function
'  Sub d02cjc_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02cjc_output( _
'      ByVal neq As long, _
'      ByRef xsol As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function d02cjc_g( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d02cjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal fcn As longPtr, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal xend As double, _
    ByVal tol As double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As longPtr, _
    ByVal g As longPtr, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02ejc_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02ejc_pederv( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal pw_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02ejc_output( _
'      ByVal neq As long, _
'      ByRef xsol As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function d02ejc_g( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d02ejc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal fcn As longPtr, _
    ByVal pederv As longPtr, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal xend As double, _
    ByVal tol As double, _
    ByVal err_c As Nag_ErrorControl, _
    ByVal output As longPtr, _
    ByVal g As longPtr, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02gac_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d02gac Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal fcn As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef u As double, _
    ByRef v As long, _
    ByVal mnp As long, _
    ByRef np As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal tol As double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02gbc_fcnf( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02gbc_fcng( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal g_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d02gbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal fcnf As longPtr, _
    ByVal fcng As longPtr, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef c As double, _
    ByRef d As double, _
    ByRef gam As double, _
    ByVal mnp As long, _
    ByRef np As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal tol As double, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02mcc Lib "CLW6I26DE_nag.dll" ( _
    ByRef icom As long _
   )


   Declare Ptrsafe Sub d02mwc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal maxord As long, _
    ByVal jceval As Nag_EvaluateJacobian, _
    ByVal hmax As double, _
    ByVal h0 As double, _
    ByVal vector_tol As Nag_Boolean, _
    ByRef icom As long, _
    ByVal licom As long, _
    ByRef com As double, _
    ByVal lcom As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub D02NEZ Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal t As double, _
    ByVal y_rptr As longPtr, _
    ByVal ydot_rptr As longPtr, _
    ByVal pd_rptr As longPtr, _
    ByVal cj As double, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub d02nec_res( _
'      ByVal neq As long, _
'      ByVal t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02nec_jac( _
'      ByVal neq As long, _
'      ByVal t As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal ydot_rptr As longPtr, _
'      ByVal pd_rptr As longPtr, _
'      ByVal cj As double, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d02nec Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByRef t As double, _
    ByVal tout As double, _
    ByRef y As double, _
    ByRef ydot As double, _
    ByRef rtol As double, _
    ByRef atol As double, _
    ByRef itask As long, _
    ByVal res As longPtr, _
    ByVal jac As longPtr, _
    ByRef icom As long, _
    ByRef com As double, _
    ByVal lcom As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02npc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal ml As long, _
    ByVal mu As long, _
    ByRef icom As long, _
    ByVal licom As long, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02pec_f( _
'      ByVal t As double, _
'      ByVal n As long, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d02pec Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As longPtr, _
    ByVal n As long, _
    ByVal twant As double, _
    ByRef tgot As double, _
    ByRef ygot As double, _
    ByRef ypgot As double, _
    ByRef ymax As double, _
    ByRef comm As Nag_Comm, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02pfc_f( _
'      ByVal t As double, _
'      ByVal n As long, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d02pfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal f As longPtr, _
    ByVal n As long, _
    ByRef tnow As double, _
    ByRef ynow As double, _
    ByRef ypnow As double, _
    ByRef comm As Nag_Comm, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02pgc Lib "CLW6I26DE_nag.dll" ( _
    ByRef irevcm As long, _
    ByVal n As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02phc Lib "CLW6I26DE_nag.dll" ( _
    ByRef irevcm As long, _
    ByVal n As long, _
    ByVal nwant As long, _
    ByRef t As double, _
    ByRef y As double, _
    ByRef yp As double, _
    ByRef wcomm As double, _
    ByVal lwcomm As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02pjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal icheck As Nag_Boolean, _
    ByVal n As long, _
    ByVal nwant As long, _
    ByVal t As double, _
    ByVal ideriv As long, _
    ByRef sol As double, _
    ByRef wcomm As double, _
    ByVal lwcomm As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02pqc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal tstart As double, _
    ByVal tend As double, _
    ByRef yinit As double, _
    ByVal tol As double, _
    ByRef thresh As double, _
    ByVal method As Nag_RK_method, _
    ByVal errass As Nag_ErrorAssess, _
    ByVal hstart As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02prc Lib "CLW6I26DE_nag.dll" ( _
    ByVal tendnu As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02psc_f( _
'      ByVal t As double, _
'      ByVal n As long, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d02psc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal twant As double, _
    ByVal reqest As Nag_SolDeriv, _
    ByVal nwant As long, _
    ByRef ywant As double, _
    ByRef ypwant As double, _
    ByVal f As longPtr, _
    ByRef wcomm As double, _
    ByVal lwcomm As long, _
    ByRef comm As Nag_Comm, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02ptc Lib "CLW6I26DE_nag.dll" ( _
    ByRef fevals As long, _
    ByRef stepcost As long, _
    ByRef waste As double, _
    ByRef stepsok As long, _
    ByRef hnext As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02puc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef rmserr As double, _
    ByRef errmax As double, _
    ByRef terrmx As double, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02qfc_fcn( _
'      ByVal neqf As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Function d02qfc_g( _
'      ByVal neqf As long, _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal yp_rptr As longPtr, _
'      ByVal k As long, _
'      ByRef comm As Nag_User _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d02qfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neqf As long, _
    ByVal fcn As longPtr, _
    ByRef t As double, _
    ByRef y As double, _
    ByVal tout As double, _
    ByVal g As longPtr, _
    ByRef comm As Nag_User, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02qwc Lib "CLW6I26DE_nag.dll" ( _
    ByRef state As Nag_Start, _
    ByVal neqf As long, _
    ByVal vectol As Nag_Boolean, _
    ByRef atol As double, _
    ByRef rtol As double, _
    ByVal one_step As Nag_Boolean, _
    ByVal crit As Nag_Boolean, _
    ByVal tcrit As double, _
    ByVal hmax As double, _
    ByVal max_step As long, _
    ByVal neqg As long, _
    ByRef alter_g As Nag_Boolean, _
    ByVal sophist As Nag_Boolean, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02qyc Lib "CLW6I26DE_nag.dll" ( _
    ByRef opt As Nag_ODE_Adams _
   )


   Declare Ptrsafe Sub d02qzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neqf As long, _
    ByVal twant As double, _
    ByVal nwant As long, _
    ByRef ywant As double, _
    ByRef ypwant As double, _
    ByRef opt As Nag_ODE_Adams, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub D02GAZ Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal x As double, _
    ByVal eps As double, _
    ByVal y_rptr As longPtr, _
    ByVal f_rptr As longPtr, _
    ByRef comm As Nag_User _
  )

   Declare Ptrsafe Sub D02GAY Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal eps As double, _
    ByVal ya_rptr As longPtr, _
    ByVal yb_rptr As longPtr, _
    ByVal aj_rptr As longPtr, _
    ByVal bj_rptr As longPtr, _
    ByRef comm As Nag_User _
  )

   Declare Ptrsafe Sub D02GAW Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal x As double, _
    ByVal eps As double, _
    ByVal y_rptr As longPtr, _
    ByVal f_rptr As longPtr, _
    ByRef comm As Nag_User _
  )

   Declare Ptrsafe Sub D02GAX Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByVal eps As double, _
    ByVal ya_rptr As longPtr, _
    ByVal yb_rptr As longPtr, _
    ByVal bcep_rptr As longPtr, _
    ByRef comm As Nag_User _
  )

' skeleton code for callback function
'  Sub d02rac_fcn( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal eps As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02rac_g( _
'      ByVal neq As long, _
'      ByVal eps As double, _
'      ByVal ya_rptr As longPtr, _
'      ByVal yb_rptr As longPtr, _
'      ByVal bc_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02rac_jacobf( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal eps As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d02rac_jacobg( _
'      ByVal neq As long, _
'      ByVal eps As double, _
'      ByVal ya_rptr As longPtr, _
'      ByVal yb_rptr As longPtr, _
'      ByVal aj_rptr As longPtr, _
'      ByVal bj_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d02rac_jaceps( _
'      ByVal neq As long, _
'      ByVal x As double, _
'      ByVal eps As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d02rac_jacgep( _
'      ByVal neq As long, _
'      ByVal eps As double, _
'      ByVal ya_rptr As longPtr, _
'      ByVal yb_rptr As longPtr, _
'      ByVal bcep_rptr As longPtr, _
'      ByRef comm As Nag_User _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d02rac Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByRef deleps As double, _
    ByVal fcn As longPtr, _
    ByVal numbeg As long, _
    ByVal nummix As long, _
    ByVal g As longPtr, _
    ByVal init As Nag_MeshSet, _
    ByVal mnp As long, _
    ByRef np As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByVal tol As double, _
    ByRef abt As double, _
    ByVal jacobf As longPtr, _
    ByVal jacobg As longPtr, _
    ByVal jaceps As longPtr, _
    ByVal jacgep As longPtr, _
    ByRef comm As Nag_User, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d02tlc_ffun( _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02tlc_fjac( _
'      ByVal x As double, _
'      ByVal y_rptr As longPtr, _
'      ByVal neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal dfdy_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02tlc_gafun( _
'      ByVal ya_rptr As longPtr, _
'      ByVal neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal nlbc As long, _
'      ByVal ga_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02tlc_gbfun( _
'      ByVal yb_rptr As longPtr, _
'      ByVal neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal nrbc As long, _
'      ByVal gb_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02tlc_gajac( _
'      ByVal ya_rptr As longPtr, _
'      ByVal neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal nlbc As long, _
'      ByVal dgady_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02tlc_gbjac( _
'      ByVal yb_rptr As longPtr, _
'      ByVal neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal nrbc As long, _
'      ByVal dgbdy_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d02tlc_guess( _
'      ByVal x As double, _
'      ByVal neq As long, _
'      ByVal m_iptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByVal dym_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d02tlc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ffun As longPtr, _
    ByVal fjac As longPtr, _
    ByVal gafun As longPtr, _
    ByVal gbfun As longPtr, _
    ByVal gajac As longPtr, _
    ByVal gbjac As longPtr, _
    ByVal guess As longPtr, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02tvc Lib "CLW6I26DE_nag.dll" ( _
    ByVal neq As long, _
    ByRef m As long, _
    ByVal nlbc As long, _
    ByVal nrbc As long, _
    ByVal ncol As long, _
    ByRef tols As double, _
    ByVal mxmesh As long, _
    ByVal nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef rcomm As double, _
    ByVal lrcomm As long, _
    ByRef icomm As long, _
    ByVal licomm As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02txc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mxmesh As long, _
    ByVal nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02tyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x As double, _
    ByRef y As double, _
    ByVal neq As long, _
    ByVal mmax As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02tzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal mxmesh As long, _
    ByRef nmesh As long, _
    ByRef mesh As double, _
    ByRef ipmesh As long, _
    ByRef ermx As double, _
    ByRef iermx As long, _
    ByRef ijermx As long, _
    ByRef rcomm As double, _
    ByRef icomm As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02uac Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02ubc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal q As long, _
    ByRef c As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02ucc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef x As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02udc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef f As double, _
    ByRef fd As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02uec Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal m As long, _
    ByRef c As double, _
    ByRef bmat As double, _
    ByRef y As double, _
    ByRef bvec As double, _
    ByRef f As double, _
    ByRef uc As double, _
    ByRef resid As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02uwc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByVal nip As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef xip As double, _
    ByRef fip As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02uyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal n As long, _
    ByRef w As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d02uzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal k As long, _
    ByVal x As double, _
    ByRef t As double, _
    ByRef fail As NagError _
   )


' chapter d03

   Declare Ptrsafe Sub d03ncc Lib "CLW6I26DE_nag.dll" ( _
    ByVal kopt As Nag_OptionType, ByVal x As double, ByVal mesh As Nag_MeshType, _
    ByVal ns As long, ByRef s As double, ByVal nt As long, _
    ByRef t As double, ByRef tdpar As Nag_Boolean, ByRef r As double, _
    ByRef q As double, ByRef sigma As double, ByVal alpha As double, _
    ByVal ntkeep As long, ByRef f As double, ByRef theta As double, _
    ByRef delta As double, ByRef gamma As double, ByRef lambda As double, _
    ByRef rho As double, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03ndc Lib "CLW6I26DE_nag.dll" ( _
    ByVal kopt As Nag_OptionType, _
    ByVal x As double, _
    ByVal s As double, _
    ByVal t As double, _
    ByVal tmat As double, _
    ByRef tdpar As Nag_Boolean, _
    ByRef r As double, _
    ByRef q As double, _
    ByRef sigma As double, _
    ByRef f As double, _
    ByRef theta As double, _
    ByRef delta As double, _
    ByRef gamma As double, _
    ByRef lambda As double, _
    ByRef rho As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03nec Lib "CLW6I26DE_nag.dll" ( _
    ByVal t0 As double, _
    ByVal tmat As double, _
    ByVal ntd As long, _
    ByRef td As double, _
    ByRef phid As double, _
    ByRef phiav As double, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d03pcc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pcc_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d03pcc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal acc As double, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d03pdc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal nptl As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pdc_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pdc_uinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d03pdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByVal nbkpts As long, ByRef xbkpts As double, _
    ByVal npoly As long, ByVal npts As long, ByRef x As double, _
    ByVal uinit As longPtr, _
    ByVal acc As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


' skeleton code for callback function
'  Sub d03pec_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pec_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ibnd As long, _
'      ByVal nobc As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d03pec Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, ByRef u As double, _
    ByVal npts As long, ByRef x As double, ByVal nleft As long, _
    ByVal acc As double, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub D03PFP Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, _
    ByVal t As double, _
    ByVal x As double, _
    ByVal u_rptr As longPtr, _
    ByVal ux_rptr As longPtr, _
    ByVal p_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal d_rptr As longPtr, _
    ByVal s_rptr As longPtr, _
    ByRef ires As long, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub d03pfc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByVal s_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d03pfc_numflx( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal uleft_rptr As longPtr, _
'      ByVal uright_rptr As longPtr, _
'      ByVal flux_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef saved As Nag_D03_Save _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pfc_bndary( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d03pfc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As longPtr, _
    ByVal numflx As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByRef acc As double, ByVal tsmax As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub D03PCK Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, _
    ByVal t As double, _
    ByVal ncode As long, _
    ByVal v_rptr As longPtr, _
    ByVal vdot_rptr As longPtr, _
    ByVal nxi As long, _
    ByVal xi_rptr As longPtr, _
    ByVal ucp_rptr As longPtr, _
    ByVal ucpx_rptr As longPtr, _
    ByVal rcp_rptr As longPtr, _
    ByVal ucpt_rptr As longPtr, _
    ByVal ucptx_rptr As longPtr, _
    ByVal f_rptr As longPtr, _
    ByRef ires As long, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub d03phc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03phc_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03phc_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d03phc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal ncode As long, ByVal odedef As longPtr, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByVal itol As long, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )



' skeleton code for callback function
'  Sub d03pjc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal nptl As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pjc_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pjc_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d03pjc_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub d03pjc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByVal nbkpts As long, ByRef xbkpts As double, _
    ByVal npoly As long, ByVal npts As long, ByRef x As double, _
    ByVal ncode As long, ByVal odedef As longPtr, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByVal uvinit As longPtr, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByRef rsave As double, ByVal lrsave As long, ByRef isave As long, _
    ByVal lisave As long, ByVal itask As long, ByVal itrace As long, _
    ByVal outfile As String, ByRef ind As long, _
    ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub D03PEK Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, _
    ByVal t As double, _
    ByVal ncode As long, _
    ByVal v_rptr As longPtr, _
    ByVal vdot_rptr As longPtr, _
    ByVal nxi As long, _
    ByVal xi_rptr As longPtr, _
    ByVal ucp_rptr As longPtr, _
    ByVal ucpx_rptr As longPtr, _
    ByVal ucpt_rptr As longPtr, _
    ByVal r_rptr As longPtr, _
    ByRef ires As long, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub d03pkc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pkc_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ibnd As long, _
'      ByVal nobc As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal ut_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03pkc_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d03pkc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, ByRef u As double, _
    ByVal npts As long, ByRef x As double, ByVal nleft As long, _
    ByVal ncode As long, ByVal odedef As longPtr, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByVal itol As long, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub D03PLP Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, _
    ByVal t As double, _
    ByVal x As double, _
    ByVal u_rptr As longPtr, _
    ByVal ux_rptr As longPtr, _
    ByVal ncode As long, _
    ByVal v_rptr As longPtr, _
    ByVal vdot_rptr As longPtr, _
    ByVal p_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal d_rptr As longPtr, _
    ByVal s_rptr As longPtr, _
    ByRef ires As long, _
    ByRef comm As Nag_Comm _
  )


' skeleton code for callback function
'  Sub d03plc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByVal s_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d03plc_numflx( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal uleft_rptr As longPtr, _
'      ByVal uright_rptr As longPtr, _
'      ByVal flux_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef saved As Nag_D03_Save _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03plc_bndary( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03plc_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d03plc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As longPtr, _
    ByVal numflx As longPtr, _
    ByVal bndary As longPtr, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal ncode As long, ByVal odedef As longPtr, _
    ByVal nxi As long, _
    ByRef xi As double, ByVal neqn As long, ByRef rtol As double, _
    ByRef atol As double, ByVal itol As long, ByVal norm As Nag_NormType, _
    ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, ByRef rsave As double, _
    ByVal lrsave As long, ByRef isave As long, ByVal lisave As long, _
    ByVal itask As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef ind As long, ByRef comm As Nag_Comm, _
    ByRef saved As Nag_D03_Save, ByRef fail As NagError _
   )



   Declare Ptrsafe Sub D03PCL Lib "CLW6I26DE_nag.dll" ( _
    ByVal t As double, _
    ByVal npts As long, _
    ByVal npde As long, _
    ByVal x_rptr As longPtr, _
    ByVal u_rptr As longPtr, _
    ByVal r_rptr As longPtr, _
    ByVal fmon_rptr As longPtr, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub d03ppc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal q_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03ppc_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal beta_rptr As longPtr, _
'      ByVal gamma_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03ppc_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal nxi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xi_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03ppc_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal rcp_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal ucptx_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d03ppc_monitf( _
'      ByVal t As double, _
'      ByVal npts As long, _
'      ByVal npde As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByVal fmon_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d03ppc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByVal m As long, ByRef ts As double, _
    ByVal tout As double, ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByVal uvinit As longPtr, ByRef u As double, ByVal npts As long, _
    ByRef x As double, ByVal ncode As long, ByVal odedef As longPtr, _
    ByVal nxi As long, ByRef xi As double, ByVal neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByVal remesh As Nag_Boolean, ByVal nxfix As long, ByRef xfix As double, _
    ByVal nrmesh As long, ByVal dxmesh As double, ByVal trmesh As double, _
    ByVal ipminf As long, ByVal xratio As double, ByVal con As double, _
    ByVal monitf As longPtr, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )



   Declare Ptrsafe Sub D03PEL Lib "CLW6I26DE_nag.dll" ( _
    ByVal t As double, _
    ByVal npts As long, _
    ByVal npde As long, _
    ByVal x_rptr As longPtr, _
    ByVal u_rptr As longPtr, _
    ByVal fmon_rptr As longPtr, _
    ByRef comm As Nag_Comm _
  )

' skeleton code for callback function
'  Sub d03prc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal udot_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03prc_bndary( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ibnd As long, _
'      ByVal nobc As long, _
'      ByVal u_rptr As longPtr, _
'      ByVal udot_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal res_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03prc_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal nxi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xi_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03prc_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d03prc_monitf( _
'      ByVal t As double, _
'      ByVal npts As long, _
'      ByVal npde As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal fmon_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d03prc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As longPtr, _
    ByVal bndary As longPtr, _
    ByVal uvinit As longPtr, _
    ByRef u As double, ByVal npts As long, ByRef x As double, _
    ByVal nleft As long, ByVal ncode As long, ByVal odedef As longPtr, _
    ByVal nxi As long, ByRef xi As double, ByVal neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByVal remesh As Nag_Boolean, ByVal nxfix As long, ByRef xfix As double, _
    ByVal nrmesh As long, ByVal dxmesh As double, ByVal trmesh As double, _
    ByVal ipminf As long, ByVal xratio As double, ByVal con As double, _
    ByVal monitf As longPtr, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )





' skeleton code for callback function
'  Sub d03psc_pdedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal u_rptr As longPtr, _
'      ByVal ux_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal p_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal d_rptr As longPtr, _
'      ByVal s_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d03psc_numflx( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal x As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal uleft_rptr As longPtr, _
'      ByVal uright_rptr As longPtr, _
'      ByVal flux_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm, _
'      ByRef saved As Nag_D03_Save _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03psc_bndary( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal t As double, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal ibnd As long, _
'      ByVal g_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03psc_uvinit( _
'      ByVal npde As long, _
'      ByVal npts As long, _
'      ByVal nxi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xi_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub d03psc_odedef( _
'      ByVal npde As long, _
'      ByVal t As double, _
'      ByVal ncode As long, _
'      ByVal v_rptr As longPtr, _
'      ByVal vdot_rptr As longPtr, _
'      ByVal nxi As long, _
'      ByVal xi_rptr As longPtr, _
'      ByVal ucp_rptr As longPtr, _
'      ByVal ucpx_rptr As longPtr, _
'      ByVal ucpt_rptr As longPtr, _
'      ByVal r_rptr As longPtr, _
'      ByRef ires As long, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub d03psc_monitf( _
'      ByVal t As double, _
'      ByVal npts As long, _
'      ByVal npde As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal u_rptr As longPtr, _
'      ByVal fmon_rptr As longPtr, _
'      ByRef comm As Nag_Comm _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub d03psc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, ByRef ts As double, ByVal tout As double, _
    ByVal pdedef As longPtr, _
    ByVal numflx As longPtr, _
    ByVal bndary As longPtr, _
    ByVal uvinit As longPtr, ByRef u As double, ByVal npts As long, _
    ByRef x As double, ByVal ncode As long, ByVal odedef As longPtr, _
    ByVal nxi As long, ByRef xi As double, ByVal neqn As long, _
    ByRef rtol As double, ByRef atol As double, ByVal itol As long, _
    ByVal norm As Nag_NormType, ByVal laopt As Nag_LinAlgOption, ByRef algopt As double, _
    ByVal remesh As Nag_Boolean, ByVal nxfix As long, ByRef xfix As double, _
    ByVal nrmesh As long, ByVal dxmesh As double, ByVal trmesh As double, _
    ByVal ipminf As long, ByVal xratio As double, ByVal con As double, _
    ByVal monitf As longPtr, ByRef rsave As double, ByVal lrsave As long, _
    ByRef isave As long, ByVal lisave As long, ByVal itask As long, _
    ByVal itrace As long, ByVal outfile As String, ByRef ind As long, ByRef comm As Nag_Comm, ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03puc Lib "CLW6I26DE_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03pvc Lib "CLW6I26DE_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByVal path As Nag_OsherVersion, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03pwc Lib "CLW6I26DE_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03pxc Lib "CLW6I26DE_nag.dll" ( _
    ByRef uleft As double, _
    ByRef uright As double, _
    ByVal gamma As double, _
    ByVal tol As double, _
    ByVal niter As long, _
    ByRef flux As double, _
    ByRef saved As Nag_D03_Save, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03pyc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, _
    ByRef u As double, _
    ByVal nbkpts As long, _
    ByRef xbkpts As double, _
    ByVal npoly As long, _
    ByVal npts As long, _
    ByRef xp As double, _
    ByVal intpts As long, _
    ByVal itype As long, _
    ByRef up As double, _
    ByRef rsave As double, _
    ByVal lrsave As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d03pzc Lib "CLW6I26DE_nag.dll" ( _
    ByVal npde As long, _
    ByVal m As long, _
    ByRef u As double, _
    ByVal npts As long, _
    ByRef x As double, _
    ByRef xp As double, _
    ByVal intpts As long, _
    ByVal itype As long, _
    ByRef up As double, _
    ByRef fail As NagError _
   )


' chapter d04

' skeleton code for callback function
'  Function d04aac_fun( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d04aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal xval As double, _
    ByVal nder As long, _
    ByVal hbase As double, _
    ByRef der As double, _
    ByRef erest As double, _
    ByVal fun As longPtr, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d04bac Lib "CLW6I26DE_nag.dll" ( _
    ByRef xval As double, _
    ByRef fval As double, _
    ByRef der As double, _
    ByRef erest As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d04bbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal x_0 As double, _
    ByVal hbase As double, _
    ByRef xval As double _
   )


' chapter d05

' skeleton code for callback function
'  Function d05aac_k1( _
'      ByVal x As double, _
'      ByVal s As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05aac_k2( _
'      ByVal x As double, _
'      ByVal s As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05aac_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d05aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal lambda As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByVal k1 As longPtr, _
    ByVal k2 As longPtr, _
    ByVal g As longPtr, _
    ByVal kform As Nag_KernelForm, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d05abc_k( _
'      ByVal x As double, _
'      ByVal s As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05abc_g( _
'      ByVal x As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d05abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal lambda As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByVal n As long, _
    ByVal k As longPtr, _
    ByVal g As longPtr, _
    ByVal odorev As Nag_Boolean, _
    ByVal ev As Nag_Boolean, _
    ByRef f As double, _
    ByRef c As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d05bac_ck( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05bac_cg( _
'      ByVal s As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05bac_cf( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d05bac Lib "CLW6I26DE_nag.dll" ( _
    ByVal ck As longPtr, _
    ByVal cg As longPtr, _
    ByVal cf As longPtr, _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As long, _
    ByVal alim As double, _
    ByVal tlim As double, _
    ByVal tol As double, _
    ByVal nmesh As long, _
    ByVal thresh As double, _
    ByRef work As double, _
    ByVal lwk As long, _
    ByRef yn As double, _
    ByRef errest As double, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d05bdc_ck( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05bdc_cf( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05bdc_cg( _
'      ByVal s As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d05bdc Lib "CLW6I26DE_nag.dll" ( _
    ByVal ck As longPtr, _
    ByVal cf As longPtr, _
    ByVal cg As longPtr, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As long, _
    ByVal tlim As double, _
    ByVal tolnl As double, _
    ByVal nmesh As long, _
    ByRef yn As double, _
    ByRef rwsav As double, _
    ByVal lrwsav As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


' skeleton code for callback function
'  Function d05bec_ck( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05bec_cf( _
'      ByVal t As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

' skeleton code for callback function
'  Function d05bec_cg( _
'      ByVal s As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function

   Declare Ptrsafe Sub d05bec Lib "CLW6I26DE_nag.dll" ( _
    ByVal ck As longPtr, _
    ByVal cf As longPtr, _
    ByVal cg As longPtr, _
    ByVal wtmode As Nag_WeightMode, _
    ByVal iorder As long, _
    ByVal tlim As double, _
    ByVal tolnl As double, _
    ByVal nmesh As long, _
    ByRef yn As double, _
    ByRef rwsav As double, _
    ByVal lrwsav As long, _
    ByRef comm As Nag_Comm, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d05bwc Lib "CLW6I26DE_nag.dll" ( _
    ByVal method As Nag_ODEMethod, _
    ByVal iorder As long, _
    ByVal nomg As long, _
    ByRef omega As double, _
    ByRef sw As double, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d05byc Lib "CLW6I26DE_nag.dll" ( _
    ByVal iorder As long, _
    ByVal iq As long, _
    ByRef omega As double, _
    ByRef sw As double, _
    ByRef fail As NagError _
   )


' chapter d06

   Declare Ptrsafe Sub d06aac Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvb As long, _
    ByVal nvmax As long, _
    ByVal nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef bspace As double, _
    ByVal smooth As Nag_Boolean, _
    ByVal coef As double, _
    ByVal power As double, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d06abc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvb As long, _
    ByVal nvint As long, _
    ByVal nvmax As long, _
    ByVal nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef weight As double, _
    ByVal npropa As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d06acc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nvb As long, _
    ByVal nvint As long, _
    ByVal nvmax As long, _
    ByVal nedge As long, _
    ByRef edge As long, _
    ByRef nv As long, _
    ByRef nelt As long, _
    ByRef coor As double, _
    ByRef conn As long, _
    ByRef weight As double, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Function D06BAD Lib "CLW6I26DE_nag.dll" ( _
    ByVal i As long, _
    ByVal x As double, _
    ByVal y As double, _
    ByRef comm As Nag_Comm _
  ) As double

' skeleton code for callback function
'  Function d06bac_fbnd( _
'      ByVal i As long, _
'      ByVal x As double, _
'      ByVal y As double, _
'      ByRef comm As Nag_Comm _
'    ) As double
'      ' your code here
'  End Function


   Declare Ptrsafe Sub d06bac Lib "CLW6I26DE_nag.dll" ( _
    ByVal nlines As long, ByRef coorch As double, ByRef lined As long, _
    ByVal fbnd As longPtr, ByRef crus As double, ByVal sdcrus As long, _
    ByRef rate As double, ByVal ncomp As long, ByRef nlcomp As long, _
    ByRef lcomp As long, ByVal nvmax As long, ByVal nedmx As long, _
    ByRef nvb As long, ByRef coor As double, ByRef nedge As long, _
    ByRef edge As long, ByVal itrace As long, ByVal outfile As String, ByRef comm As Nag_Comm, ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d06cac Lib "CLW6I26DE_nag.dll" ( _
    ByVal nv As long, _
    ByVal nelt As long, _
    ByVal nedge As long, _
    ByRef coor As double, _
    ByRef edge As long, _
    ByRef conn As long, _
    ByVal nvfix As long, _
    ByRef numfix As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByVal nqint As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d06cbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nv As long, _
    ByVal nelt As long, _
    ByVal nnzmax As long, _
    ByRef conn As long, _
    ByRef nnz As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d06ccc Lib "CLW6I26DE_nag.dll" ( _
    ByVal nv As long, _
    ByVal nelt As long, _
    ByVal nedge As long, _
    ByVal nnzmax As long, _
    ByRef nnz As long, _
    ByRef coor As double, _
    ByRef edge As long, _
    ByRef conn As long, _
    ByRef irow As long, _
    ByRef icol As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d06dac Lib "CLW6I26DE_nag.dll" ( _
    ByVal mode As long, _
    ByVal nv As long, _
    ByVal nedge As long, _
    ByVal nelt As long, _
    ByVal ntrans As long, _
    ByRef itype As long, _
    ByRef trans As double, _
    ByRef coori As double, _
    ByRef edgei As long, _
    ByRef conni As long, _
    ByRef cooro As double, _
    ByRef edgeo As long, _
    ByRef conno As long, _
    ByVal itrace As long, _
    ByVal outfile As String, _
    ByRef fail As NagError _
   )


   Declare Ptrsafe Sub d06dbc Lib "CLW6I26DE_nag.dll" ( _
    ByVal eps As double, ByVal nv1 As long, ByVal nelt1 As long, _
    ByVal nedge1 As long, ByRef coor1 As double, ByRef edge1 As long, _
    ByRef conn1 As long, ByRef reft1 As long, ByVal nv2 As long, _
    ByVal nelt2 As long, ByVal nedge2 As long, ByRef coor2 As double, _
    ByRef edge2 As long, ByRef conn2 As long, ByRef reft2 As long, _
    ByRef nv3 As long, ByRef nelt3 As long, ByRef nedge3 As long, _
    ByRef coor3 As double, ByRef edge3 As long, ByRef conn3 As long, _
    ByRef reft3 As long, ByVal itrace As long, ByVal outfile As String, _
    ByRef fail As NagError _
   )


